<?php
class SlideDeckLens_HalfMoon extends SlideDeckLens_Scaffold {
    var $options_model = array(
		'Setup' => array(
			'navigation-position' => array(
				'name' => 'navigation-position',
				'type' => 'select',
				'values' => array(
					'nav-bottom' => 'Bottom',
					'nav-top' => 'Top'
				),
				'value' => 'nav-bottom',
				'label' => 'Navigation Position'
			)
		),
		'Appearance' => array(
            'hideSpines' => array(
                'type' => 'hidden',
                'value' => true
            )
        ),
		'Navigation' => array(
			'navigation-style' => array(
				'name' => 'navigation-style',
				'type' => 'select',
				'values' => array(
					'nav-inside' => 'Inside',
					'nav-outside' => 'Outside'
				),
				'value' => 'nav-inside',
				'label' => 'Navigation Style',
				'weight' => 30
			)
        ),
        'Content' => array(
            'date-format' => array(
                'value' => "human-readable-abbreviated"
            )
        )
    );
    function __construct(){
        
        parent::__construct();
        // added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_half-moon", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_half-moon", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );
        
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_half-moon", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_half-moon", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );
        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_half-moon", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_half-moon", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_half-moon", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_half-moon", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_half-moon", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core
    }
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {
        
        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {
        
        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#' . $slidedeck_unique_id . '-frame img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#' . $slidedeck_unique_id . '-frame").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {
        
        $html .= '<dl id="' . $slidedeck_unique_id . '" class="' . implode( " ", $slidedeck_classes ) . '" style="' . $slidedeck_styles_str . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {
        
        $html.= '</dl>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {
        
        $html .= '<div id="' . $slidedeck_unique_id . '-frame" class="' . implode( " ", $frame_classes ) . '" style="' . $frame_styles_str . '" data-sd2-lazy-load-padding="' . $slidedeck_lazy_load_padding . '" data-sd3-image_protection="' . $slidedeck_image_protection . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '<a class="deck-navigation horizontal prev" href="#prev-horizontal"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation horizontal next" href="#next-horizontal"><span>Next</span></a>';
        $html .= '<a class="deck-navigation vertical prev" href="#prev-vertical"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation vertical next" href="#next-vertical"><span>Next</span></a>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {
        
        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {
        
// $output .= "<dt". ( (!empty( $spine_classes ) ) ? ' class="'. implode( " ", $spine_classes ) . '"' :'') . ( (!empty( $spine_styles ) ) ? ' style="'. $spine_styles . '"' :'') .">{$slide_title}</dt>";
        if( $slide['type'] == "video" ){
            $output .= '<dd itemprop="video" itemscope itemtype="http://schema.org/VideoObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        } else {
            $output .= '<dd itemscope="" itemtype="http://schema.org/ImageObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        }
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {
        
        $output .= "</dd>";
        return $output;
    }
    function slidedeck_options_model( $options_model, $slidedeck ) {
        if( $this->is_valid( $slidedeck['lens'] ) ) {
            // Check to see if the deck type even supports date-format
            if( $options_model['Content']['date-format'] != 'hidden' ) {
                $options_model['Content']['date-format']['value'] = "human-readable-abbreviated";
                $options_model['Content']['date-format']['values'] = array(
                    'none' => "Do not show",
                    'human-readable-abbreviated' => date( "M j" )
                );
            }
        }
        
        return $options_model;
    }
    
   	/**
     * Add appropriate classes for this Lens to the SlideDeck frame
     * 
     * @param array $slidedeck_classes Classes to be applied
     * @param array $slidedeck The SlideDeck object being rendered
     * 
     * @return array
     */
    function slidedeck_frame_classes( $slidedeck_classes, $slidedeck ) {
        if( $this->is_valid( $slidedeck['lens'] ) ) {
        	$slidedeck_classes[] = $this->prefix . $slidedeck['options']['navigation-position'];
        	$slidedeck_classes[] = $this->prefix . $slidedeck['options']['navigation-style'];
        }
        return $slidedeck_classes;
    }
    
    function slidedeck_dimensions(&$width, &$height, &$outer_width, &$outer_height, &$slidedeck){
		if( $this->is_valid( $slidedeck['lens'] ) ) {
			$width = $outer_width - 2;
			$height = $outer_height - 2;
			
			if( $slidedeck['options']['navigation-style'] == 'nav-outside' ) {
				$height = $outer_height - 35;
			}
		}
	}

	/**
	 * Append options to bottom of the setup list
	 * 
	 * @param array $slidedeck
	 */
	function slidedeck_setup_options_bottom( $slidedeck ) {
		if( $this->is_valid( $slidedeck['lens'] ) ) {
			echo '<li>' . slidedeck_html_input( "options[navigation-position]", $slidedeck['options']['navigation-position'], $this->options_model['Setup']['navigation-position'], false ) . '</li>';
		}
	}
    
    /**
     * Hook into slidedeck_slide_nodes filter
     * 
     * @param array $nodes Array of slide nodes
     * @param array $slidedeck SlideDeck object
     * 
     * @return array
     */
    function slidedeck_slide_nodes( $nodes, $slidedeck ) {
        if( $this->is_valid( $slidedeck['lens'] ) ) {
            // Revert created_at back to a timestamp so it can be output special in the template
            $nodes['created_at'] = is_numeric( $nodes['created_at'] ) ? $nodes['created_at'] : strtotime( $nodes['created_at'] );
        }
        
        return $nodes;
    }
}
