jQuery(function($){

	"use strict";
	var SlidedeckLayerProIframe = {
		Models : {},
		Views : {}
	};

	/*==============================
	      		 LayerPro
	===============================*/

	SlidedeckLayerProIframe.Models.LayerPro = Backbone.Model.extend({

	    defaults: {
			php_function         : '',
			post_id              : '',
			slide_id  	         : '',
			perPosX 	         : '',
			perPosY 	         : '',
			zindex 				 : ''
	    },

	});

	SlidedeckLayerProIframe.Views.LayerPro = Backbone.View.extend({

	    el : '.lens-layerpro',

	    events: {
	    	'click .sdl-add-opacity' : 'addOpacity',
	    	'click .sdl-save-layers' : 'save',
	    },

	    initialize: function(){
	    	this.makeDraggable();
	    	$(window).on( 'load', this.addImageCSS );
	    },

	    makeDraggable : function(){

	    	var _this = this, $this, position, positions, slidedeckWidth, width;

	    	var $layers = $('.sdl-slide-layer img, .sdl-slide-layer span');

	    	var count = 1;

	    	$layers.draggable({
			//iframeFix : true,
		  
    		  start : function( event, ui ){
    		  	$(this).css( "z-index", count++ );
			$(this).css("transition","none");
    		  },
			  stop: function( event, ui )
			  {
		  		position = ui.position;

		  		positions =  _this.convertInPercentage( ui.position.left, ui.position.top );
                                slidedeckWidth = $(window).width();
                                width =$(this).parent().data('width')// ( $layers.width()/ slidedeckWidth ) * 100;//( layerWidth / slidedeckWidth ) * 100;
				
                                if($layers.parent().data('width') ===  undefined){
                                     width = ( $layers.parent().width()/ slidedeckWidth )+'%';
                                }
		  		$(this).parent()
		  		.data( 'z-index' , $(this).css('z-index') )
		  		.data( 'slide-id' , $(this).closest('.slide').data('slide-id') )
		  		.data( 'per-position-x' , positions[0] )
		  		.data( 'per-position-y' , positions[1] )
                                .data( 'width' , width );
		  		$('button.sdl-save-layers').prop( 'disabled', false ).text("Save");
			  }
			});
	    },

	    addImageCSS : function(){

	    	var $slidedeck = $('.lens-layerpro');
	    	var layerWidth, slidedeckWidth, widthInPercentage, left, top, zIndex;

	    	$slidedeck.each(function(){

	    		slidedeckWidth = $(window).width();

	    		$(this).find('.sdl-slide-layer').each(function(){

					layerWidth        = $(this).find('img').attr('width');
					widthInPercentage = $(this).data('width') ? $(this).data('width') : 100;///( layerWidth / slidedeckWidth ) * 100;
					left              = $(this).data('position-x') > -1 ? $(this).data('position-x') : 20;
					top               = $(this).data('position-y') > -1 ? $(this).data('position-y') : 20;
					zIndex            = $(this).data('z-index') ? $(this).data('z-index') : 20;
                                        
	    			$(this).css( {
	    				'width' : widthInPercentage + '%',
	    				'z-index' : zIndex,
	    				'left' : left + '%',
	    				'top' : top + '%'
	    			});

	    		});
	    	});


	    },

	    convertInPercentage : function( posX, posY )
	    {
	    	var $slider = $('.slide'),
	    		decimalPlace = 10000000,
	    		x = ( 100 * posX ) / $slider.width() ,
	    		y = ( 100 * posY ) / $slider.height();

	    		x = x < 0 ? 0 : Math.round( x * decimalPlace ) / decimalPlace;
	    		y = y < 0 ? 0 : Math.round( y * decimalPlace ) / decimalPlace;

	    	return [ x, y ];
	    },

	    addOpacity : function(e){
	    	var $this = $(e.currentTarget);
	    	e.preventDefault();

	    	var $colors = [ 'rgba(128, 0, 128, 0.29)', 'rgba(68, 68, 68, 0.35)', 'rgba(255, 0, 0, 0.18)', 'rgba(255, 255, 0, 0.28)' , 'rgba(0, 128, 0, 0.38)' ];
	    	var $thisSlide = $this.closest('.slide');

	    	if( $this.hasClass('active') ){
	    		$this.text("Add Opacity");
	    		$this.removeClass('active');
	    		$thisSlide.find('.sdl-slide-layer').each(function( index, el ){
	    			$(this).css( {
	    				'background-color' : 'transparent',
	    				'border' : 'none'
	    			});
	    		});
	    	}
	    	else{
	    		$this.text("Remove Opacity");
	    		$this.addClass('active');
	    		$thisSlide.find('.sdl-slide-layer').each(function( index, el ){
	    			$(this).css({
	    				'background-color' : $colors[index],
	    				'border' : '2px dotted #ccc'
	    			});
	    		});
	    	}
	    },

	    save : function(e)
	    {
	    	var $this = $(e.currentTarget);
	    	var $slidedeck = $('.lens-layerpro');
	    	var $layer;
	    	var layers = [];

	    	$slidedeck.find('.slide').each(function(){
	    		$(this).find('.sdl-slide-layer').each(function(){
                            
	    			if( $(this).data('slide-id') ){
	    				layers.push({
	    					'layer'          : $(this).data('layer'),
	    					'per_cordinates' : [ $(this).data('per-position-x') , $(this).data('per-position-y') ],
	    					'z_index'        : $(this).data('z-index'),
	    					'slide_id'       : $(this).data('slide-id'),
                                                'width'          : $(this).data('width'),
                                                'duration'       : $(this).data('duration'),
                                                'delay'          : $(this).data('delay'),
                                                'scale'          : $(this).data('scale'),
                                                'skewx'          : $(this).data('skewx'),
                                                'skewy'          : $(this).data('skewy'),
                                                'rotate'         : $(this).data('rotate'),
                                                'ease'           : $(this).data('ease'),
                                                'color'          : $(this).data('color'),
                                                'background'     : $(this).data('background'),
                                                'bkgwidth'     : $(this).data('bkgwidth'),
                                                'bkgheight'     : $(this).data('bkgheight'),
                                                'radius'     : $(this).data('radius'),
                                                'family'       : $(this).data('family'),
                                                'font'       : $(this).data('font'),
                                                'type'       : $(this).data('type'),
                                                'offsetx'       : $(this).data('offsetx'),
                                                'offsety'       : $(this).data('offsety'),
                                                'durationo'       : $(this).data('durationo'),
                                                'delayo'          : $(this).data('delayo'),
                                                'scaleo'          : $(this).data('scaleo'),
                                                'skewxo'          : $(this).data('skewxo'),
                                                'skewyo'          : $(this).data('skewyo'),
                                                'rotateo'         : $(this).data('rotateo'),
                                                'easeo'           : $(this).data('easeo'),
                                                'offsetxo'       : $(this).data('offsetxo'),
                                                'offsetyo'       : $(this).data('offsetyo'),
                                                'fstyle'           : $(this).data('fstyle'),
                                                'fweight'           : $(this).data('fweight'),
	    				});
	    			}
	    		});
	    	});
              
	    	var ajaxData = {
	    		'action' : 'sdl_save_layers',
	    		'layers' : layers
	    	};

	    	$this.text("Saving...").prop('disabled', true);

	    	

	    	$.ajax({
	    		url: slidedeckLayerProAdminURL,
	    		type: 'POST',
	    		dataType: 'json',
	    		data: ajaxData,
	    	})
	    	.done(function( resp ){
    		
	    	})
	    	.always(function(){
	    		$this.text("Saved");
	    	});

	    },


	});


	SlidedeckLayerProIframe.LayerPro = new SlidedeckLayerProIframe.Views.LayerPro( { model : new SlidedeckLayerProIframe.Models.LayerPro() } );

});
