<?php
if (!defined("SLIDEDECK_LAYERPRO_DIRNAME")) define("SLIDEDECK_LAYERPRO_DIRNAME", dirname(__FILE__));
if (!defined("SLIDEDECK_LAYERPRO_URLPATH")) define("SLIDEDECK_LAYERPRO_URLPATH", trailingslashit(plugins_url()) . 'slidedeck5addon/slidedeck-lenses/' . basename(SLIDEDECK_LAYERPRO_DIRNAME));
if (!defined("SLIDEDECK_LAYERPRO_VERSION")) define("SLIDEDECK_LAYERPRO_VERSION", "1.0.0");


class SlideDeckLens_Layerpro extends SlideDeckLens_Scaffold
{
    public $slide_count;

    function __construct(){
        parent::__construct();
        if ( ! class_exists( 'ajax-functions' ) ) {
             require_once(SLIDEDECK_LAYERPRO_DIRNAME .'/ajax-functions.php');
        }
        add_filter( "{$this->namespace}_iframe_scripts", array( $this, 'slidedeck_iframe_scripts' ), 999, 2 );

        add_filter( "{$this->namespace}_get_slides", array( &$this, "get_slides" ), 11, 2 );

        // added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_layerpro", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_layerpro", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );

        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_layerpro", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_layerpro", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );
        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_layerpro", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_layerpro", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_layerpro", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_layerpro", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_layerpro", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core

        add_action( "{$this->namespace}_slide_editor_header" , array( $this , 'slide_editor_header' ) );
        add_action( "{$this->namespace}_after_slide_editor_field" , array( $this , 'add_slide_editor_content' ) , 11 , 2 );
        add_action( "slidedeck_layerpro_fields_update", array( $this , 'update_value' ) , 12, 2 );
        add_filter( "slidedeck_slide_content" , array( $this , 'add_layers' ) , 9, 3 ); //Problem found

        add_action( 'slidedeck_iframe_header', array( $this , 'enqueue_iframe_scripts' ) );

        add_action( 'slidedeck_iframe_footer', array( $this , 'iframe_footer_scripts' ) );

        add_action( 'admin_enqueue_scripts' , array( &$this, 'enqueue_admin_scripts' ) );

        add_action( 'wp_ajax_sdl_save_layers' , array( $this , 'save_layers' ) );

        add_action( 'wp_enqueue_scripts', array( $this , 'front_scripts' ) );

        add_filter( "{$this->namespace}_options_model", array( $this, 'default_options' ), 20, 2 );

    }
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {

        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {

        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#slidedeck-'. $id.' img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#slidedeck-' . $id . '").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {

        $html .= "<ul id='slidedeck-layerpro-lens-{$id}' style='" . $slidedeck_styles_str . " max-width:100%;' class='slidedeck-layerpro-lens lens-layerpro' >";
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {

        $html.= '</ul>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {

        $html .= "<div id='{$slidedeck_unique_id}' class='slidedeck-layerpro-null'></div>";
        $html .= "<div id='slidedeck-{$id}' style='" . $frame_styles_str . "' class='slidedeck-layerpro sdl-loading' data-sd3-image_protection='". $slidedeck_image_protection ."'>";
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '<a class="deck-navigation horizontal prev" href="#prev-horizontal"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation horizontal next" href="#next-horizontal"><span>Next</span></a>';
        $html .= '<a class="deck-navigation vertical prev" href="#prev-vertical"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation vertical next" href="#next-vertical"><span>Next</span></a>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {

        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {
        wp_enqueue_script( 'cycle-all' );
        if( $slide['type'] == "video" ){
            $output .= '<li itemscope="" itemtype="http://schema.org/VideoObject" class="slide" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        } else {
            $output .= '<li itemscope="" itemtype="http://schema.org/ImageObject" class="slide" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'"  >';
        }
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {

        $output .= "</li>";
        return $output;
    }
    function default_options( $default_options, $params ) {
        if( isset( $params['lens'] ) && 'layerpro' == $params['lens'] ) {
            $default_options['Playback']['slideTransition']['values'] = array(
                'fade'       => __( 'Fade' , 'supernova' ),
                'scrollHorz' => __( 'Slide Horizontally' , 'supernova' )
            );

        }

        return $default_options;
    }

    function front_scripts(){
        wp_register_script( 'sdl-cycle' , SLIDEDECK_LAYERPRO_URLPATH . '/jquery.cycle2.min.js', array('jquery'), SLIDEDECK_LAYERPRO_VERSION , true );
        wp_register_script( 'sdl-layerpro' , SLIDEDECK_LAYERPRO_URLPATH . '/jquery.layerpro.js', array('jquery'), SLIDEDECK_LAYERPRO_VERSION , true  );
        wp_register_script( 'sdl-extras' , SLIDEDECK_LAYERPRO_URLPATH . '/lens.add.js', array('jquery'), SLIDEDECK_LAYERPRO_VERSION , true  );
        wp_enqueue_script( 'sdl-layerpro' );
        wp_enqueue_script( 'sdl-cycle' );
        wp_enqueue_script('jquery-effects-core');
        wp_enqueue_script('jquery-effects-blind');
        wp_enqueue_script("jquery-effects-core");
        wp_enqueue_script( 'sdl-extras' );
        // wp_enqueue_script( 'scrolling-js' );
    }

    /**
     *  function remove unused scripts from backend preview
     * @param type $footer_scripts
     * @param type $slidedeck
     * @return type
     */
    function slidedeck_iframe_scripts( $footer_scripts, $slidedeck )
    {
        if ( $this->is_valid( $slidedeck['lens'] ) ) {
            return $footer_scripts;
        } else {
            return $footer_scripts;
        }
    }

    function is_preview(){
        return isset( $_GET['action'] ) && $_GET['action'] === 'slidedeck_preview_iframe';
    }

    function enqueue_admin_scripts(){
        if( isset( $_GET['page'] ) && $_GET['page'] === 'slidedeck.php' ){
            wp_enqueue_media();
            wp_enqueue_script( "{$this->namespace}-layerpro-add-js", SLIDEDECK_LAYERPRO_URLPATH . '/lens.add.js'  );
            wp_enqueue_script(  "{$this->namespace}-layerpro-admin-js", SLIDEDECK_LAYERPRO_URLPATH . '/lens.admin.js' );
            wp_enqueue_style(  "{$this->namespace}-layerpro-admin-css", SLIDEDECK_LAYERPRO_URLPATH . '/lens.admin.css' );

        }
    }

    function enqueue_iframe_scripts()
    {
        $admin_url = admin_url( 'admin-ajax.php' );
        echo '<link rel="stylesheet" type="text/css" href="'.SLIDEDECK_LAYERPRO_URLPATH.'/lens.admin.css">';

        echo "<script> var slidedeckLayerProAdminURL = '{$admin_url}'; </script>";
    }

    function iframe_footer_scripts(){
        $js_path = includes_url( 'js/' );
        echo '<script src="'.SLIDEDECK_LAYERPRO_URLPATH.'/jquery-ui.min.js"></script>';
        echo "<script src='" . $js_path . "underscore.min.js' ></script>";
        echo "<script src='" . $js_path . "backbone.min.js' ></script>";
        echo "<script src='" . SLIDEDECK_LAYERPRO_URLPATH . "/jquery.cycle2.min.js' ></script>";
        echo "<script src='" . SLIDEDECK_LAYERPRO_URLPATH . "/jquery.layerpro.js' ></script>";
        echo "<script src='" . SLIDEDECK_LAYERPRO_URLPATH . "/iframe.script.js' ></script>";
        echo "<script src='" . SLIDEDECK_LAYERPRO_URLPATH . "/lens.js' ></script>";
        echo "<script src='" . SLIDEDECK_LAYERPRO_URLPATH . "/lens.add.js' ></script>";
    }

    /**
     * Adding the accent-color class to the <a> tags if Twitter
     *
     * @param array $slides Array of Slides
     * @param array $slidedeck The SlideDeck object being rendered
     *
     * @uses SlideDeckLens_Scaffold::is_valid()
     *
     * @return array
     */
    function get_slides( $slides, $slidedeck ){
        if( $this->is_valid( $slidedeck['lens'] ) ){
            foreach( $slides as &$slide ){
                if( $slidedeck['source'] == 'twitter' ){
                    $slide['content'] = preg_replace( '/\<a /', '<a class="accent-color" ', $slide['content'] );
                }
            }
        }
        return $slides;
    }

    function slide_editor_header( $slide ){
        $layerpro_type = isset( $slide->meta['_layerpro_type'] ) ? $slide->meta['_layerpro_type'] : "scroll";
        ?>
        <div class="sdl-slide-checkboxes" >
            <label for="sdl-checkbox-layers"><?php _e( 'Add Layers' , 'slidedeck' ); ?></label>
            <input type="radio" name="sdl-checkbox" <?php if( $layerpro_type === 'layermove' ) echo 'checked="checked"' ?> id="sdl-checkbox-layers" value="layermove">
        </div>
        <?php
    }

    function get_data_depth_field( $key, $slide ){
        $data_depth  = intval($this->if_isset( $key , $slide->meta ));
        if( ! $data_depth ) $data_depth = 6;
        ?>
            <span class="sdl-data-depth" for=""><?php _e( 'Movement Depth : ' , 'slidedeck' ); ?></span>
            <select name="<?php echo $key; ?>" id="">
                <?php for( $i = 1 ; $i < 16; $i++ ){ ?>
                    <option value="<?php echo $i; ?>" <?php selected( $data_depth, $i );  ?> ><?php echo $i; ?></option>
                <?php } ?>
            </select>
        <?php
    }

    function add_slide_editor_content( $slide )
    {
        $ly_count = get_post_meta( $slide->ID, 'sd-layer-count', true );
        $layerpro_type              = $this->if_isset( '_layerpro_type' , $slide->meta, 'scroll' );
        $layer_array = array();
        for($b=1;$b<=$ly_count;$b++){
            $key_name = '_layermove_layer_'.$b;
            $layer_array[$b] = intval($this->if_isset( $key_name , $slide->meta ));
        }

        $options = isset($slidedeck['options']) ? $slidedeck['options'] : '';
        //$options = $slidedeck['options'];
        $sd_defaults = array(
            'layers' => array(
                'sd_transition' => array( 'value' => '', 'keys' => 'transition', 'props' => array( 'meta' => true )),

		'sd_offsetx' => array(
			'value' => '10',
			'name' => __('OffsetX', 'slidedeck'),
			'keys' => 'offsetxin',
			'tooltip' => __("The horizontal offset to align the starting position of layers. Positive and negative numbers are allowed or enter left / right to position the layer out of the frame.", "slidedeck")
		),

		'sd_offsety' => array(
			'value' => '10',
			'name' => __('OffsetY', 'slidedeck'),
			'keys' => 'offsetyin',
			'tooltip' => __("The vertical offset to align the starting position of layers. Positive and negative numbers are allowed or enter top / bottom to position the layer out of the frame.", "slidedeck")
		),


		'sd_duration' => array(
			'value' => 1000,
			'name' => __('Duration', 'slidedeck'),
			'keys' => 'durationin',
			'tooltip' => __('The transition duration in milliseconds when the layer enters into the slide. A second equals to 1000 milliseconds.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 50 )
		),


		'sd_delay' => array(
			'value' => 1000,
			'name' => __('Delay', 'slidedeck'),
			'keys' => 'delayin',
			'tooltip' => __('Delays the transition with the given amount of milliseconds before the layer enters into the slide. A second equals to 1000 milliseconds.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 50 )
		),
                'sd_width' => array(
			'value' => 50,
			'name' => __('Width', 'slidedeck'),
			'keys' => 'sdwidth',
			'tooltip' => __('Width of image in percentage', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_rotate' => array(
			'value' => 0,
			'name' => __('Rotate In Degree', 'slidedeck'),
			'keys' => 'sdrotate',
			'tooltip' => __('Rotates the layer clockwise from the given angle to zero degree', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),

                'sd_scale' => array(
			'value' => 0,
			'name' => __('Scale Image', 'slidedeck'),
			'keys' => 'sdscale',
			'tooltip' => __("Scales the layer's width from the given value to its original size.", 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_skewx' => array(
			'value' => 0,
			'name' => __('Skew X', 'slidedeck'),
			'keys' => 'sdskewx',
			'tooltip' => __("Skews the layer along the horizontal axis from the given angle in degree.", 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_skewy' => array(
			'value' => 0,
			'name' => __('Skew Y', 'slidedeck'),
			'keys' => 'sdskewy',
			'tooltip' => __("Skews the layer along the vertical axis from the given angle in degree.", 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_family' => array(
			'value' => 'Arial',
			'name' => __('Font Family', 'slidedeck'),
			'keys' => 'sdfamily',
			'tooltip' => __('List of your chosen fonts separated with a comma. Please use apostrophes if your font names contains white spaces. Example: Helvetica, Arial, sans-serif', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_font' => array(
			'value' => '12',
			'name' => __('Font Size', 'slidedeck'),
			'keys' => 'sdfont',
			'tooltip' => __('The font size in pixels. Example: 16', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_color' => array(
			'value' => '',
			'name' => __('Color', 'slidedeck'),
			'keys' => 'sdcolor',
			'tooltip' => __('The color of your text. You can use color names, hexadecimal, RGB or RGBA values. Example: #fff', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_background' => array(
			'value' => '',
			'name' => __('Background', 'slidedeck'),
			'keys' => 'sdbackground',
			'tooltip' => __('The background color of your text. You can use color names, hexadecimal, RGB or RGBA values. Example: #fff', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_bkgwidth' => array(
			'value' => '',
			'name' => __('Width', 'slidedeck'),
			'keys' => 'sdbkgwidth',
			'tooltip' => __('The background width of your text in percentage.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_bkgheight' => array(
			'value' => '',
			'name' => __('Height', 'slidedeck'),
			'keys' => 'sdbkgheight',
			'tooltip' => __('The background height of your text in percentage.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_radius' => array(
			'value' => '',
			'name' => __('Radius', 'slidedeck'),
			'keys' => 'sdradius',
			'tooltip' => __('The rouded corners for your text in percentage.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_fstyle' => array(
			'value' => '',
			'name' => __('Font Style', 'slidedeck'),
			'keys' => 'sdfstyle',
			'tooltip' => __('The rounded corners for your text in percentage.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_fweight' => array(
			'value' => '',
			'name' => __('Font Weight', 'slidedeck'),
			'keys' => 'sdfweight',
			'tooltip' => __('The rounded corners for your text in percentage.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_easein' => array(
			'value' => '',
			'name' => __('EaseIn', 'slidedeck'),
			'keys' => 'sdeasein',
			'tooltip' => __('The timing function of the animation. With this function you can manipulate the movement of the animated object.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_scaleo' => array(
			'value' => 0,
			'name' => __('Scale Image', 'slidedeck'),
			'keys' => 'sdscale',
			'tooltip' => __("Scales the layer's width from the given value to its original size.", 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_skewxo' => array(
			'value' => 0,
			'name' => __('Skew X', 'slidedeck'),
			'keys' => 'sdskewx',
			'tooltip' => __("Skews the layer along the horizontal axis from the given angle in degree.", 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_skewyo' => array(
			'value' => 0,
			'name' => __('Skew Y', 'slidedeck'),
			'keys' => 'sdskewy',
			'tooltip' => __("Skews the layer along the vertical axis from the given angle in degree.", 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                 'sd_easeino' => array(
			'value' => '',
			'name' => __('EaseIn', 'slidedeck'),
			'keys' => 'sdeasein',
			'tooltip' => __('The timing function of the animation. With this function you can manipulate the movement of the animated object.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),
                'sd_rotateo' => array(
			'value' => 0,
			'name' => __('Rotate In Degree', 'slidedeck'),
			'keys' => 'sdrotate',
			'tooltip' => __('Rotates the layer clockwise from the given angle to zero degree', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 100 )
		),


		'sd_offsetxo' => array(
			'value' => 10,
			'name' => __('OffsetX', 'slidedeck'),
			'keys' => 'offsetxin',
			'tooltip' => __("The horizontal offset to align the ending position of layers. Positive and negative numbers are allowed or enter left / right to position the layer out of the frame.", "slidedeck")
		),

		'sd_offsetyo' => array(
			'value' => 10,
			'name' => __('OffsetY', 'slidedeck'),
			'keys' => 'offsetyin',
			'tooltip' => __("The vertical offset to align the ending position of layers. Positive and negative numbers are allowed or enter top / bottom to position the layer out of the frame.", "slidedeck")
		),


		'sd_durationo' => array(
			'value' => 0,
			'name' => __('Duration', 'slidedeck'),
			'keys' => 'durationin',
			'tooltip' => __('The transition duration in milliseconds when the layer exits from the slide. A second equals to 1000 milliseconds.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 50 )
		),


		'sd_delayo' => array(
			'value' => 1000,
			'name' => __('Delay', 'slidedeck'),
			'keys' => 'delayin',
			'tooltip' => __('Delays the transition with the given amount of milliseconds before the layer exits from the slide. A second equals to 1000 milliseconds.', 'slidedeck'),
			'attrs' => array( 'min' => 0, 'step' => 50 )
		),
)
);

        ?>
        <input type="hidden" name="_layerpro_type" class="sdl_layerpro_type_field" value="<?php echo $layerpro_type; ?>" >

        <li class="sdl-add-layers sdl-hide">

            <div class="sd-add-layer-class">
            <div class="sd-new-layer">
            <input type="button" value="Add Layer" class="sd_add_layers" id="sd_abc">
            <?php for($i =1; $i<=$ly_count; $i++) {
                $sd_text_value_key = "_layermove_layer_".$i;
                $sd_text_value = get_post_meta( $slide->ID, $sd_text_value_key, true );
                $img_template = wp_get_attachment_image( $layer_array[$i] , 'thumbnail' );
                if(!empty($img_template)|| !empty($sd_text_value)){
                ?>
            <div class="sdl-right" data-value="<?php echo $i ?>">
                <span class="sdl-thumbnail">Layer #<?php echo $i ?>

                </span>
                <span class="sdl-cross"></span>
            </div>
                <?php
                }
                else{ ?>
            <div class="sdl-right" data-value="<?php echo $i ?>" style="display: none">
                    <span class="sdl-thumbnail">Layer #<?php echo $i ?>
                    </span>
                    </div>
                <?php }

                } ?>
            </div>


            <div class="sd-show-layers">

                <div class="sd-input-radio"><input type="radio" value="Add Image" class="sd_add_images" onclick="layerpro_add_layers('image',<?php echo $slide->ID; ?>)">Add Image
                <input type="radio" value="Add text" class="sd_add_text" onclick="layerpro_add_layers('text',<?php echo $slide->ID; ?>)">Add Text
                </div>


            <!--</div>-->

            <ul>

                <div class="sd-main-layer-class">

                <?php
                    $ly_count = get_post_meta( $slide->ID, 'sd-layer-count', true );

                    $slideid = $slide->ID;
                    for($i =1; $i<=$ly_count; $i++) {
                        $sd_animation_key = "_layermove_layer_".$i."_data";
                        $sd_animation_array = get_post_meta( $slideid, $sd_animation_key, true );

                        if($sd_animation_array['sd_type'] == 'image'){
                            include(SLIDEDECK_LAYERPRO_DIRNAME .'/image-template.php');
                        }
                        elseif($sd_animation_array['sd_type'] == 'text'){
                            include(SLIDEDECK_LAYERPRO_DIRNAME .'/text-template.php');
                        }
                    }
                ?>
                    </div>

                <input type="hidden" class="sd-layer-count" name="sd-layer-count" value="">
            </ul>
            </div>
                 </div>
        </li>
        <?php
    }

    function update_value( $slide, $data )
    {

        if( ! isset( $data['_layerpro_type'] ) || empty( $slide ) || empty( $data ) ) return;
         if( $data['_layerpro_type'] === 'layermove' )
        {
            update_post_meta( $slide->ID, "_layerpro_type", 'layermove' );

            if( isset( $data['_layermove_data_depth'] ) ){
                update_post_meta( $slide->ID, "_layermove_data_depth", $data['_layermove_data_depth'] );
            }

            if( isset( $data['_layermove_caption_image'] ) ){
                update_post_meta( $slide->ID, "_layermove_caption_image", $data['_layermove_caption_image'] );
            }
            if( isset( $data['sd-layer-count'] ) ){
                update_post_meta( $slide->ID, "sd-layer-count", $data['sd-layer-count'] );
            }
            if( isset( $data['sd-layer-text-count'] ) ){
                update_post_meta( $slide->ID, "sd-layer-text-count", $data['sd-layer-text-count'] );
            }
            if( isset( $data['sd-layer-image-count'] ) ){
                update_post_meta( $slide->ID, "sd-layer-image-count", $data['sd-layer-image-count'] );
            }

            for($i=1; $i<=$data['sd-layer-count']; $i++){
                $layer = "_layermove_layer_".$i;
                //$layer = 'sd_text_layer';
                $offsetx = "sd_offsetx_".$i;
                $offsety = "sd_offsety_".$i;
                $sd_duration = "sd_duration_".$i;
                $sd_delay = "sd_delay_".$i;
                $sd_width = "sd_width_".$i;
                $sd_effects = "sd_effects_".$i;
                $sd_scale = "sd_scale_".$i;
                $sd_skewx = "sd_skewx_".$i;
                $sd_skewy = "sd_skewy_".$i;
                $sd_rotate = "sd_rotate_".$i;
                $sd_ease = "sd_ease_".$i;
                $offsetxo = "sd_offsetxo_".$i;
                $offsetyo = "sd_offsetyo_".$i;
                $sd_durationo = "sd_durationo_".$i;
                $sd_delayo = "sd_delayo_".$i;
                $sd_scaleo = "sd_scaleo_".$i;
                $sd_skewxo = "sd_skewxo_".$i;
                $sd_skewyo = "sd_skewyo_".$i;
                $sd_rotateo = "sd_rotateo_".$i;
                $sd_easeo = "sd_easeo_".$i;
                $sd_family = "sd_family_".$i;
                $sd_font = "sd_font_".$i;
                $sd_color = "sd_color_".$i;
                $sd_background = "sd_background_".$i;
                $sd_bkgwidth = "sd_bkgwidth_".$i;
                $sd_bkgheight = "sd_bkgheight_".$i;
                $sd_radius = "sd_radius_".$i;
                $sd_type = "sd_type_".$i;
                $sd_coordinatex = "sd_coordinate_x_".$i;
                $sd_coordinatey = "sd_coordinate_y_".$i;
                $sd_fstyle = "sd_fstyle_".$i;
                $sd_fweight = "sd_fweight_".$i;
                if( isset( $data[$layer] ) ){
                    $temp[$data[$layer]] = array();
                    if( isset( $data[$offsetx] ) ){
                        $temp[$layer]['sd_offsetx'] = $data[$offsetx] ;
                    }

                    if( isset( $data[$offsety] ) ){
                        $temp[$layer]["sd_offsety"] = $data[$offsety] ;
                    }

                    if( isset( $data[$sd_duration] ) ){
                        $temp[$layer]["sd_duration"] = $data[$sd_duration] ;
                    }
                    if( isset( $data[$sd_delay] ) ){
                        $temp[$layer]["sd_delay"] = $data[$sd_delay] ;
                    }
                    if( isset( $data[$sd_width] ) ){
                        $temp[$layer]["sd_width"] = $data[$sd_width] ;
                    }
                    if( isset( $data[$sd_scale] ) ){
                        $temp[$layer]["sd_scale"] = $data[$sd_scale] ;
                    }
                    if( isset( $data[$sd_skewx] ) ){
                        $temp[$layer]["sd_skewx"] = $data[$sd_skewx] ;
                    }
                    if( isset( $data[$sd_skewy] ) ){
                        $temp[$layer]["sd_skewy"] = $data[$sd_skewy] ;
                    }
                    if( isset( $data[$sd_rotate] ) ){
                        $temp[$layer]["sd_rotate"] = $data[$sd_rotate] ;
                    }
                    if( isset( $data[$sd_ease] ) ){
                        $temp[$layer]["sd_ease"] = $data[$sd_ease] ;
                    }
                    if( isset( $data[$offsetxo] ) ){
                        $temp[$layer]['sd_offsetxo'] = $data[$offsetxo] ;
                    }

                    if( isset( $data[$offsetyo] ) ){
                        $temp[$layer]["sd_offsetyo"] = $data[$offsetyo] ;
                    }

                    if( isset( $data[$sd_durationo] ) ){
                        $temp[$layer]["sd_durationo"] = $data[$sd_durationo] ;
                    }
                    if( isset( $data[$sd_delayo] ) ){
                        $temp[$layer]["sd_delayo"] = $data[$sd_delayo] ;
                    }
                    if( isset( $data[$sd_scaleo] ) ){
                        $temp[$layer]["sd_scaleo"] = $data[$sd_scaleo] ;
                    }
                    if( isset( $data[$sd_skewxo] ) ){
                        $temp[$layer]["sd_skewxo"] = $data[$sd_skewxo] ;
                    }
                    if( isset( $data[$sd_skewyo] ) ){
                        $temp[$layer]["sd_skewyo"] = $data[$sd_skewyo] ;
                    }
                    if( isset( $data[$sd_rotateo] ) ){
                        $temp[$layer]["sd_rotateo"] = $data[$sd_rotateo] ;
                    }
                    if( isset( $data[$sd_easeo] ) ){
                        $temp[$layer]["sd_easeo"] = $data[$sd_easeo] ;
                    }
                    if( isset( $data[$sd_font] ) ){
                        $temp[$layer]["sd_font"] = $data[$sd_font] ;
                    }
                    if( isset( $data[$sd_family] ) ){
                        $temp[$layer]["sd_family"] = $data[$sd_family] ;
                    }
                    if( isset( $data[$sd_color] ) ){
                        $temp[$layer]["sd_color"] = $data[$sd_color] ;
                    }
                    if( isset( $data[$sd_background] ) ){
                        $temp[$layer]["sd_background"] = $data[$sd_background] ;
                    }
                    if( isset( $data[$sd_bkgwidth] ) ){
                        $temp[$layer]["sd_bkgwidth"] = $data[$sd_bkgwidth] ;
                    }
                    if( isset( $data[$sd_bkgheight] ) ){
                        $temp[$layer]["sd_bkgheight"] = $data[$sd_bkgheight] ;
                    }
                    if( isset( $data[$sd_radius] ) ){
                        $temp[$layer]["sd_radius"] = $data[$sd_radius] ;
                    }
                    if( isset( $data[$sd_type] ) ){
                        $temp[$layer]["sd_type"] = $data[$sd_type] ;
                    }
                    if( isset( $data[$sd_coordinatex] ) ){
                        $temp[$layer]["cordinates"][0] = $data[$sd_coordinatex] ;
                    }
                    if( isset( $data[$sd_coordinatey] ) ){
                        $temp[$layer]["cordinates"][1] = $data[$sd_coordinatey] ;
                    }
                    if( isset( $data[$sd_fstyle] ) ){
                        $temp[$layer]["sd_fstyle"] = $data[$sd_fstyle] ;
                    }
                    if( isset( $data[$sd_fweight] ) ){
                        $temp[$layer]["sd_fweight"] = $data[$sd_fweight] ;
                    }
                    update_post_meta( $slide->ID, $layer, $data[$layer] );
                    update_post_meta( $slide->ID, $layer."_data", $temp[$layer] );

                }
            }


        }
    }

    function if_isset( $key , $array, $default_value = false ){
        return isset( $array[$key] ) ? $array[$key] : $default_value;
    }

    function add_layers( $content, $slide, $slidedeck )
    {
        $slide_id    = isset( $slide['id'] ) ? $slide['id'] : false;
        $slide_index = $this->slide_count;
        $lens     = isset( $slidedeck['lens'] ) ? $slidedeck['lens'] : false;

        if( $lens !== 'layerpro' ) return $content;

        $this->slide_count++;

        if( ! $slide_id ){ return;}

        $scroll_meta_keys = array(
                            '_scroll_caption_image'
                            );
         $layerpro_type = get_post_meta( $slide_id, '_layerpro_type', true );
$layermove_meta_keys = array();
        $sd_layer_count = get_post_meta( $slide_id, 'sd-layer-count', true );
        for($k=1;$k<=$sd_layer_count;$k++){
            $layermove_meta_keys[] = '_layermove_layer_'.$k;
        }

        //if( ! $layerpro_type ) {echo 'in1111111';return;}

        $options = $slidedeck['options'];
        $data   = array(
                        'class'                   => "sdl-layers layerpro-type-{$layerpro_type}" ,
                        'data-layerpro-type'      => $layerpro_type,
                        'data-continueScrolling'  => $this->if_isset( 'continueScrolling', $options ),
                        'data-autoPlay'           => $this->if_isset( 'autoPlay', $options ),
                        'data-autoPlayInterval'   => $this->if_isset( 'autoPlayInterval', $options ),
                        'data-cycle'              => $this->if_isset( 'cycle', $options ),
                        'data-slideTransition'    => $this->if_isset( 'slideTransition', $options ),
                        'data-speed'              => $this->if_isset( 'speed', $options ),
                        'data-keys'               => $this->if_isset( 'keys', $options ),
                        'data-scroll'             => $this->if_isset( 'scroll', $options ),
                        'data-start'              => $this->if_isset( 'start', $options ),
                        'data-display-nav-arrows' => $this->if_isset( 'display-nav-arrows', $options ),
                        'data-touch'              => $this->if_isset( 'touch', $options ),
                    );

        $data_string = '';

        foreach ( $data as $attr => $value ) {
            $data_string .= "{$attr}='{$value}' ";
        }

        $markup = "<ul {$data_string} >";

        if( $layerpro_type === 'scroll' ){

            $data_depth = intval(get_post_meta( $slide_id, '_scroll_data_depth', true ));
            foreach ( $scroll_meta_keys as $key => $meta_key ) {
                $markup .= $this->get_layer( $slide_id, $meta_key, $key, $data_depth );
            }

        }
        else if( $layerpro_type === 'layermove' ){

            $data_depth = intval(get_post_meta( $slide_id, '_layermove_data_depth', true ));
            foreach ( $layermove_meta_keys as $key => $meta_key )
            {
                $markup .= $this->get_layer( $slide_id, $meta_key, $key , $data_depth );
            }
        }

        if( $this->is_preview() ){
            $markup .= "<div class='sdl-layer-actions'>";
            // $markup .=  "<button class='button sdl-add-opacity' >Add Opacity</button>";
            $markup .=  "<button class='button sdl-save-layers' >Save</button>";
            $markup .= "</div>";
        }

        $markup .= "</ul>";

        return $markup . $content;
    }

    function get_layer( $slide_id, $meta_key, $key, $data_depth )
    {
        $markup = false;
        $key++;
        $default_data_depth =  $key * 6 / 10;
        $depth = $data_depth > 0 ? $default_data_depth * ($data_depth/10) : $default_data_depth;

        $attachment_id    = get_post_meta( $slide_id, $meta_key , true );
        $layer_data       = get_post_meta( $slide_id, $meta_key . '_data' , true );
        $position_x       = isset( $layer_data['cordinates'] ) && ! empty( $layer_data['cordinates'] ) ? $layer_data['cordinates'][0] : false;
        $position_y       = isset( $layer_data['cordinates'] ) && ! empty( $layer_data['cordinates'] ) ? $layer_data['cordinates'][1] : false;
        $offset_x       =  ! empty( $layer_data['sd_offsetx'] ) ? $layer_data['sd_offsetx'] : false;
        $offset_y       =  ! empty( $layer_data['sd_offsety'] ) ? $layer_data['sd_offsety'] : false;
        $layer_width       =  ! empty( $layer_data['sd_width'] ) ? $layer_data['sd_width'] : false;
        $layer_delay       =  ! empty( $layer_data['sd_delay'] ) ? $layer_data['sd_delay'] : false;
        $layer_duration       =  ! empty( $layer_data['sd_duration'] ) ? $layer_data['sd_duration'] : false;
        $layer_rotate      =  ! empty( $layer_data['sd_rotate'] ) ? $layer_data['sd_rotate'] : false;
        $layer_scale      =  ! empty( $layer_data['sd_scale'] ) ? $layer_data['sd_scale'] : false;
        $layer_skewx      =  ! empty( $layer_data['sd_skewx'] ) ? $layer_data['sd_skewx'] : false;
        $layer_skewy      =  ! empty( $layer_data['sd_skewy'] ) ? $layer_data['sd_skewy'] : false;
        $layer_ease      =  ! empty( $layer_data['sd_ease'] ) ? $layer_data['sd_ease'] : false;
        $offset_xo       =  ! empty( $layer_data['sd_offsetxo'] ) ? $layer_data['sd_offsetxo'] : false;
        $offset_yo       =  ! empty( $layer_data['sd_offsetyo'] ) ? $layer_data['sd_offsetyo'] : false;

        $layer_delayo       =  ! empty( $layer_data['sd_delayo'] ) ? $layer_data['sd_delayo'] : false;
        $layer_durationo       =  ! empty( $layer_data['sd_durationo'] ) ? $layer_data['sd_durationo'] : false;
        $layer_rotateo      =  ! empty( $layer_data['sd_rotateo'] ) ? $layer_data['sd_rotateo'] : false;
        $layer_scaleo      =  ! empty( $layer_data['sd_scaleo'] ) ? $layer_data['sd_scaleo'] : false;
        $layer_skewxo      =  ! empty( $layer_data['sd_skewxo'] ) ? $layer_data['sd_skewxo'] : false;
        $layer_skewyo      =  ! empty( $layer_data['sd_skewyo'] ) ? $layer_data['sd_skewyo'] : false;
        $layer_easeo      =  ! empty( $layer_data['sd_easeo'] ) ? $layer_data['sd_easeo'] : false;
        $layer_font      =  ! empty( $layer_data['sd_font'] ) ? $layer_data['sd_font'] : false;
        $layer_family      =  ! empty( $layer_data['sd_family'] ) ? $layer_data['sd_family'] : false;
        $layer_color      =  ! empty( $layer_data['sd_color'] ) ? $layer_data['sd_color'] : false;
        $layer_background      =  ! empty( $layer_data['sd_background'] ) ? $layer_data['sd_background'] : false;
        $layer_bkgwidth      =  ! empty( $layer_data['sd_bkgwidth'] ) ? $layer_data['sd_bkgwidth'] : false;
        $layer_bkgheight      =  ! empty( $layer_data['sd_bkgheight'] ) ? $layer_data['sd_bkgheight'] : false;
        $layer_radius      =  ! empty( $layer_data['sd_radius'] ) ? $layer_data['sd_radius'] : false;
        $layer_type      =  ! empty( $layer_data['sd_type'] ) ? $layer_data['sd_type'] : false;
        $layer_fstyle      =  ! empty( $layer_data['sd_fstyle'] ) ? $layer_data['sd_fstyle'] : false;
        $layer_fweight      =  ! empty( $layer_data['sd_fweight'] ) ? $layer_data['sd_fweight'] : false;
        $data   = array(
                        'class'           => 'layer sdl-slide-layer sdl-scroll-caption-layer slidedeck-layerpro-position' ,
                        'data-depth'      => $depth,
                        'data-selected-depth' => $data_depth,
                        'data-layer'      => $meta_key,
                        'data-z-index'    => $this->if_isset( 'z_index' , $layer_data ),
                        'data-position-x' => $position_x,
                        'data-position-y' => $position_y,
                        'data-width'      => $layer_width."%",
                        'data-delay'      => $layer_delay,
                        'data-ease'       => $layer_ease,
                        'data-duration'   => $layer_duration,
                        'data-scale'      => $layer_scale,
                        'data-skewx'      => $layer_skewx,
                        'data-skewy'      => $layer_skewy,
                        'data-rotate'     => $layer_rotate,
                        'data-offsetx'    => $offset_x,
                        'data-offsety'    => $offset_y,
                        'data-delayo'      => $layer_delayo,
                        'data-easeo'       => $layer_easeo,
                        'data-durationo'   => $layer_durationo,
                        'data-scaleo'      => $layer_scaleo,
                        'data-skewxo'      => $layer_skewxo,
                        'data-skewyo'      => $layer_skewyo,
                        'data-rotateo'     => $layer_rotateo,
                        'data-offsetxo'    => $offset_xo,
                        'data-offsetyo'    => $offset_yo,
                        'data-font'    => $layer_font,
                        'data-family'    => $layer_family,
                        'data-color'    => $layer_color,
                        'data-background'    => $layer_background,
                        'data-bkgwidth'    => $layer_bkgwidth,
                        'data-bkgheight'    => $layer_bkgheight,
                        'data-radius'    => $layer_radius,
                        'data-type'    => $layer_type,
                        'data-fstyle'   => $layer_fstyle,
                        'data-fweight'  => $layer_fweight
                        );

        $data_string = '';

        foreach ( $data as $attr => $value ) {
            $data_string .= "{$attr}='{$value}' ";
        }

        if($layer_type === 'image') {
            $attachemnt_image = wp_get_attachment_image( $attachment_id, 'full', false );
            if( !empty($attachemnt_image) ){
                $markup = "<li {$data_string} >";
                $markup .= $attachemnt_image;
                $markup .= '</li>';
            }
            /*
            elseif(!empty($attachment_id)){
                $markup = "<li {$data_string} >";
                $markup .= "<span class='sd_text_value'>".$attachment_id."</span>";
                $markup .= '</li>';
            }
            */
        } else {
            $markup = "<li {$data_string} >";
            $markup .= "<span class='sd_text_value'>".$attachment_id."</span>";
            $markup .= '</li>';
        }

        return $markup;
    }

    function save_layers()
    {
        $layers = $this->if_isset( 'layers' , $_REQUEST );

        $response = "error saving the layer...";

        if( empty( $layers ) ) return;
        foreach ( $layers as $layer )
        {
            $data               = array();
            //$cordinates = $this->if_isset( 'per_cordinates' , $layer );
            $slide_id           = $this->if_isset( 'slide_id' , $layer );
            $layer_meta_key     = $this->if_isset( 'layer' , $layer );
            $data['cordinates'] = $this->if_isset( 'per_cordinates' , $layer );
            $data['z_index']    = $this->if_isset( 'z_index' , $layer );
            $data['sd_width']    = trim($this->if_isset( 'width' , $layer ),'%');
            $data['sd_duration']    = $this->if_isset( 'duration' , $layer );
            $data['sd_delay']    = $this->if_isset( 'delay' , $layer );
            $data['sd_rotate']    = $this->if_isset( 'rotate' , $layer );
            $data['sd_scale']    = $this->if_isset( 'scale' , $layer );
            $data['sd_skewx']    = $this->if_isset( 'skewx' , $layer );
            $data['sd_skewy']    = $this->if_isset( 'skewy' , $layer );
            $data['sd_family']    = $this->if_isset( 'family' , $layer );
            $data['sd_font']    = $this->if_isset( 'font' , $layer );
            $data['sd_color']    = $this->if_isset( 'color' , $layer );
            $data['sd_background']    = $this->if_isset( 'background' , $layer );
            $data['sd_bkgwidth']    = $this->if_isset( 'bkgwidth' , $layer );
            $data['sd_bkgheight']    = $this->if_isset( 'bkgheight' , $layer );
            $data['sd_radius']    = $this->if_isset( 'radius' , $layer );
            $data['sd_ease']    = $this->if_isset( 'ease' , $layer );
            $data['sd_type']    = $this->if_isset( 'type' , $layer );
            $data['sd_offsetx']    = $this->if_isset( 'offsetx' , $layer );
            $data['sd_offsety']    = $this->if_isset( 'offsety' , $layer );
            $data['sd_offsetxo']    = $this->if_isset( 'offsetxo' , $layer );
            $data['sd_offsetyo']    = $this->if_isset( 'offsetyo' , $layer );
            $data['sd_durationo']    = $this->if_isset( 'durationo' , $layer );
            $data['sd_delayo']    = $this->if_isset( 'delayo' , $layer );
            $data['sd_rotateo']    = $this->if_isset( 'rotateo' , $layer );
            $data['sd_scaleo']    = $this->if_isset( 'scaleo' , $layer );
            $data['sd_skewxo']    = $this->if_isset( 'skewxo' , $layer );
            $data['sd_skewyo']    = $this->if_isset( 'skewyo' , $layer );
            $data['sd_easeo']    = $this->if_isset( 'easeo' , $layer );
            $data['sd_fstyle']    = $this->if_isset( 'fstyle' , $layer );
            $data['sd_weight']    = $this->if_isset( 'fweight' , $layer );
            if( ! $slide_id || ! $layer_meta_key ) continue;

            update_post_meta( $slide_id , $layer_meta_key . '_data' , $data  );

            $response = "Layer Saved..";

        }

        die(json_encode( $response ));
    }

}

?>
