(function($){
    SlideDeckLens['leather'] = function(slidedeck){
        var ns = 'leather';
        var deck = $(slidedeck).slidedeck();
        var elems = {};
            // The SlideDeck DOM element itself
            elems.slidedeck = deck.deck;
            // The SlideDeck's frame
            elems.frame = elems.slidedeck.closest('.lens-' + ns);
            // The slides within the SlideDeck
            elems.horizontalSlides = deck.slides;
            // Get the accent color
            elems.accentColor = elems.frame.find('.accent-color').css('color');
		
		// Only for IE - detect background image url and update style for DD element
    	if( slidedeck_ie <= 8.0 ){
    		elems.horizontalSlides.each(function(ind){
    			if( $(elems.horizontalSlides[ind]).css('background-image') != 'none' ){
    				var imgurl = $(elems.horizontalSlides[ind]).css('background-image').match( /url\([\"\'](.*)[\"\']\)/ )[1];
    				$(elems.horizontalSlides[ind]).css({
    					background: 'none'
    				});
    				elems.horizontalSlides[ind].style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + imgurl + "', sizingMethod='scale')";
    			};
    		});
    	}
        
        deck.slides.each(function(ind){            
            var $slide = deck.slides.eq(ind);            
            $slide.find('.sd2-node-caption a.play-video-alternative').addClass('accent-color');
        });
        
        deck.loaded(function( thedeck ){
            elems.frame.append('<span class="sd2-page-tear">&nbsp;</span>');
            
            var playAlts = elems.slidedeck.find('a.play-video-alternative');
            // Add click events to the individual playAlts.
            playAlts.each(function(){
                var elem = $(this);
                
                // Append the icon-shape element and use it as the Raphael paper.
                elem.append('<span class="icon-shape-wrapper"><span class="icon-shape"></span></span>');
                var iconWrapper = elem.find('.icon-shape');
                var width = iconWrapper.width();
                var height = iconWrapper.height();
                var paper = Raphael( iconWrapper[0], width, height );

                var pointerShape = paper.path( "M8.42,0C3.77,0,0,3.77,0,8.42s3.77,8.42,8.42,8.42s8.42-3.77,8.42-8.42S13.07,0,8.42,0z   M7,13.708V3.132l5.8,5.287L7,13.708z" );
                //var shapeElement = $( pointerShape.node );
                pointerShape.attr({
                  stroke: 'none',
                  fill: elems.accentColor
                });
                
                // Define the data property to adjust the color.
                iconWrapper.data('slidedeck-accent-shape', pointerShape);
                
            });
        });
        
        this.dotNavigation = function(){
            if( elems.frame.hasClass('sd2-nav-dots') ) {         
                var maxDots = 50;
            
                var slideCount = elems.slidedeck.find('dd.slide').length;
                var navWrapper = '<div class="sd2-dot-nav-wrapper"><div class="sd2-dot-nav-texture">&nbsp;</div><div class="sd2-stitching">&nbsp;</div></div>';
                var navHtml = '<div class="sd2-dot-nav"></div>';
                $(navWrapper).appendTo(elems.frame);
                $(navHtml).appendTo(elems.frame.find('.sd2-dot-nav-wrapper'));
                var dotNav = elems.frame.find('.sd2-dot-nav');
                for( i = 0; i < Math.min( slideCount, maxDots ); i++ ) {
                    $('<span>&bull;</span>').appendTo(dotNav);
                }
                var navDots = dotNav.find('span');
                //dotNav.css( 'width', Math.min( slideCount, maxDots ) * ( navDots.outerWidth(true) ))
                dotNav.css( 'margin-left', -( dotNav.outerWidth(true) / 2) );
                navDots.eq( deck.current-1 ).addClass('active');
                // ADD CLICK FUNCTIONS
                navDots.bind('click', function(){
                    var $self = $(this);
                    deck.goTo(($self).index()+1);
                    navDots.removeClass('active');
                    $self.addClass('active');
                });
            }
        }
        
        // Get the old complete option
        var oldComplete = deck.options.complete;
        
        deck.setOption('complete', function(){
            // If the old complete option was a function, run it
            if(typeof(oldComplete) == 'function') {
                oldComplete(deck);
            }
        });
        
        var oldBefore = deck.options.before;
        deck.setOption('before', function(deck){
            if(typeof(oldBefore) == 'function')
               oldBefore(deck);
            
            // Bind the callbacks to the dot nav
            if( elems.frame.hasClass('sd2-nav-dots') ){
                var navDots = elems.frame.find('.sd2-dot-nav').find('span');
                navDots.removeClass('active');
                navDots.eq(deck.current-1).addClass('active');
            }
        });
        
        this.dotNavigation();
    };
    
    $(document).ready(function(){
        $('.lens-leather .slidedeck').each(function(){
            if(typeof($.data(this, 'lens-leather')) == 'undefined' || $.data(this, 'lens-leather') == null){
                $.data(this, 'lens-leather', new SlideDeckLens['leather'](this));
            }
        });
    });
})(jQuery);