<?php
class SlideDeckLens_OTown extends SlideDeckLens_Scaffold {
    var $options_model = array(
        'Appearance' => array(
            'accentColor' => array(
                'value' => "#ff00ff"
            ),	
		 'position' => array(
                'name' => 'slider',
                'type' => 'select',
                'value' => 'frame',
                'values' => array(
                    'nav-left' => 'left',
                    'nav-right' => 'right',
                  
                ),
                'label' => 'Position',
                'description' => "Choose the thickness of the frame around your SlideDeck",
                'weight' => 40
            ),
            'titleFont' => array(
                'value' => "oswald"
            ),
            'hideSpines' => array(
                'type' => 'hidden',
                'value' => true
            )
        ),
        'Navigation' => array(
			'navigation-type' => array(
				'name' => 'navigation-type',
				'type' => 'select',
				'values' => array(
                    'nav-numbers' => 'Numbers',
                    'nav-dots' => 'Dots',
                    'nav-thumb' => "Thumbnails",
		   		),
				'value' => 'nav-numbers',
				'label' => 'Navigation Type',
				'description' => "Note: Dots Navigation Type is limited to a max of 10. If you have more than 10 slides, Thumbnails is better for your users.",
				'weight' => 20
			),
		),
        'Content' => array(
            'date-format' => array()
        ),
        'Playback' => array(
			'autoplay-indicator' => array(
                'name' => 'autoplay-indicator',
                'type' => 'select',
                'values' => array(
                    'autoplay-straight' => 'Straight',
                    'autoplay-snake' => 'Snake',
                    'autoplay-hide' => 'None'
                ),
                'value' => 'autoplay-snake',
                'label' => 'AutoPlay Indicator',
                'description' => "Choose the style of the animated timer when AutoPlay and Thumbnails are enabled",
                'weight' => 30
            ),
            'slideTransition' => array(
                'type' => "hidden",
                'value' => "slide"
            )
		)
    );
	
    function __construct(){
        parent::__construct();
	// added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_o-town", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_o-town", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );
        
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_o-town", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_o-town", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );
        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_o-town", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_o-town", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_o-town", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_o-town", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_o-town", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core
        add_filter( "{$this->namespace}_get_slides", array( &$this, "slidedeck_get_slides" ), 11, 2 );
    }
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {
        
        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {
        
        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#' . $slidedeck_unique_id . '-frame img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#' . $slidedeck_unique_id . '-frame").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {
        
        $html .= '<dl id="' . $slidedeck_unique_id . '" class="' . implode( " ", $slidedeck_classes ) . '" style="' . $slidedeck_styles_str . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {
        
        $html.= '</dl>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {
        
        $html .= '<div id="' . $slidedeck_unique_id . '-frame" class="' . implode( " ", $frame_classes ) . '" style="' . $frame_styles_str . '" data-sd2-lazy-load-padding="' . $slidedeck_lazy_load_padding . '" data-sd3-image_protection="' . $slidedeck_image_protection . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '<a class="deck-navigation horizontal prev" href="#prev-horizontal"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation horizontal next" href="#next-horizontal"><span>Next</span></a>';
        $html .= '<a class="deck-navigation vertical prev" href="#prev-vertical"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation vertical next" href="#next-vertical"><span>Next</span></a>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {
        
        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {
        
// $output .= "<dt". ( (!empty( $spine_classes ) ) ? ' class="'. implode( " ", $spine_classes ) . '"' :'') . ( (!empty( $spine_styles ) ) ? ' style="'. $spine_styles . '"' :'') .">{$slide_title}</dt>";
        if( $slide['type'] == "video" ){
            $output .= '<dd itemprop="video" itemscope itemtype="http://schema.org/VideoObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        } else {
            $output .= '<dd itemscope="" itemtype="http://schema.org/ImageObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        }
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {
        
        $output .= "</dd>";
        return $output;
    }
    /**
     * Add appropriate classes for this Lens to the SlideDeck frame
     * 
     * @param array $slidedeck_classes Classes to be applied
     * @param array $slidedeck The SlideDeck object being rendered
     * 
     * @uses SlideDeckLens_Scaffold::is_valid()
     * 
     * @return array
     */
    function slidedeck_frame_classes( $slidedeck_classes, $slidedeck ) {
        if( $this->is_valid( $slidedeck['lens'] ) ) {
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['navigation-type'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['autoplay-indicator'];

		$position=$slidedeck['options']['position'];
		

		if($position=="nav-right")
		{	
			wp_enqueue_style('custom_style_otownfront', SLIDEDECK_URLPATH ."/lenses/o-town/custom.css" );

		}
        }
        
        return $slidedeck_classes;
    }
    /**
     * Making the SlideDeck process as a vertical deck
     * 
     * @param boolean $process_as_vertical default boolean - false
     * @param array $slidedeck The SlideDeck object being rendered
     * 
     * @uses SlideDeckLens_Scaffold::is_valid()
     * 
     * @return boolean
     */
    function slidedeck_process_as_vertical( $process_as_vertical, $slidedeck ){
        if( $this->is_valid( $slidedeck['lens'] ) ) {
            $process_as_vertical = true;
        }
        return $process_as_vertical;
    }
    
    
    /**
     * Removing the background-image inline style from the slide DD element
     * Background image is being used within the template on an internal element
     * Adding the accent-color class to the <a> tags if Twitter
     *
     * @param array $slides Array of Slides
     * @param array $slidedeck The SlideDeck object being rendered
     * 
     * @uses SlideDeckLens_Scaffold::is_valid()
     * 
     * @return array
     */
    function slidedeck_get_slides( $slides, $slidedeck ){
        if( $this->is_valid( $slidedeck['lens'] ) ){

            foreach( $slides as &$slide ){
                if( in_array( 'twitter', $slidedeck['source'] ) ){
                    $slide['content'] = preg_replace( '/\<a /', '<a class="accent-color" ', $slide['content'] );
                }
            }
        }
        return $slides;
    }
}
