<?php

if (!defined("SLIDEDECK_PARALLAX_DIRNAME")) define("SLIDEDECK_PARALLAX_DIRNAME", dirname(__FILE__));
if (!defined("SLIDEDECK_PARALLAX_URLPATH")) define("SLIDEDECK_PARALLAX_URLPATH", trailingslashit(plugins_url()) . 'slidedeck5addon/slidedeck-lenses/' . basename(SLIDEDECK_PARALLAX_DIRNAME));
if (!defined("SLIDEDECK_PARALLAX_VERSION")) define("SLIDEDECK_PARALLAX_VERSION", "1.0.0");

class SlideDeckLens_Parallax extends SlideDeckLens_Scaffold
{
    public $slide_count;

    function __construct(){
        parent::__construct();

        add_filter( "{$this->namespace}_iframe_scripts", array( $this, 'slidedeck_iframe_scripts' ), 999, 2 );

        add_filter( "{$this->namespace}_get_slides", array( &$this, "get_slides" ), 11, 2 );

        // added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_parallax", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_parallax", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );

        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_parallax", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_parallax", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );
        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_parallax", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_parallax", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_parallax", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_parallax", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_parallax", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core

        add_action( "{$this->namespace}_slide_editor_header" , array( $this , 'slide_editor_header' ) );
        add_action( "{$this->namespace}_after_slide_editor_field" , array( $this , 'add_slide_editor_content' ) , 11 , 1 );

        add_action( "slidedeck_parallax_fields_update", array( $this , 'update_value' ) , 10, 2 );
        add_filter( "slidedeck_slide_content" , array( $this , 'add_layers' ) , 9, 3 ); //Problem found

        add_action( 'slidedeck_iframe_header', array( $this , 'enqueue_iframe_scripts' ) );

        add_action( 'slidedeck_iframe_footer', array( $this , 'iframe_footer_scripts' ) );

        add_action( 'admin_enqueue_scripts' , array( &$this, 'enqueue_admin_scripts' ) );

        add_action( 'wp_ajax_sdp_save_layers' , array( $this , 'save_layers' ) );

        add_action( 'wp_enqueue_scripts', array( $this , 'front_scripts' ) );

        add_filter( "{$this->namespace}_options_model", array( $this, 'default_options' ), 20, 2 );

    }
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {

        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {

        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#slidedeck-'. $id.' img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#slidedeck-' . $id . '").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {

        $html .= "<ul id='slidedeck-paralax-lens-{$id}' class='slidedeck-parallax-lens lens-parallax' >";
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {

        $html.= '</ul>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {

        $html .= "<div id='{$slidedeck_unique_id}' class='slidedeck-parallax-null'></div>";
        $html .= "<div id='slidedeck-{$id}' class='slidedeck-parallax sdp-loading' data-sd3-image_protection='". $slidedeck_image_protection ."'>";
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '<a class="deck-navigation horizontal prev" href="#prev-horizontal"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation horizontal next" href="#next-horizontal"><span>Next</span></a>';
        $html .= '<a class="deck-navigation vertical prev" href="#prev-vertical"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation vertical next" href="#next-vertical"><span>Next</span></a>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {

        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {
        wp_enqueue_script( 'cycle-all' );
        if( $slide['type'] == "video" ){
            $output .= '<li itemscope="" itemtype="http://schema.org/VideoObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        } else {
            $output .= '<li itemscope="" itemtype="http://schema.org/ImageObject" class="slide" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'"  >';
        }
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {

        $output .= "</li>";
        return $output;
    }
    function default_options( $default_options, $params ) {

        if( isset( $params['lens'] ) && 'parallax' == $params['lens'] ) {
            $default_options['Playback']['slideTransition']['values'] = array(
                'fade'       => __( 'Fade' , 'supernova' ),
                'scrollHorz' => __( 'Slide Horizontally' , 'supernova' ),
                'tileSlide'  => __( 'Tile Slide' , 'supernova' ),
                'tileBlind'  => __( 'Tile Blind' , 'supernova' )
            );
        }

        return $default_options;
    }

    function front_scripts(){
        wp_register_script( 'sdp-cycle' , SLIDEDECK_PARALLAX_URLPATH . '/jquery.cycle2.min.js', array('jquery'), SLIDEDECK_PARALLAX_VERSION , true );
        wp_register_script( 'sdp-parallax' , SLIDEDECK_PARALLAX_URLPATH . '/jquery.parallax.js', array('jquery'), SLIDEDECK_PARALLAX_VERSION , true  );
        wp_enqueue_script( 'sdp-parallax' );
        wp_enqueue_script( 'sdp-cycle' );
        // wp_enqueue_script( 'scrolling-js' );
    }

    /**
     *  function remove unused scripts from backend preview
     * @param type $footer_scripts
     * @param type $slidedeck
     * @return type
     */
    function slidedeck_iframe_scripts( $footer_scripts, $slidedeck )
    {
        if ( $this->is_valid( $slidedeck['lens'] ) ) {
            return $footer_scripts;
        } else {
            return $footer_scripts;
        }
    }

    function is_preview(){
        return isset( $_GET['action'] ) && $_GET['action'] === 'slidedeck_preview_iframe';
    }

    function enqueue_admin_scripts(){
        if( isset( $_GET['page'] ) && $_GET['page'] === 'slidedeck.php' ){
            wp_enqueue_media();
            wp_enqueue_script(  "{$this->namespace}-parallax-admin-js", SLIDEDECK_PARALLAX_URLPATH . '/lens.admin.js' );
            wp_enqueue_style(  "{$this->namespace}-parallax-admin-css", SLIDEDECK_PARALLAX_URLPATH . '/lens.admin.css' );
        }
    }

    function enqueue_iframe_scripts()
    {
        $admin_url = admin_url( 'admin-ajax.php' );
        echo '<link rel="stylesheet" type="text/css" href="'.SLIDEDECK_PARALLAX_URLPATH.'/lens.admin.css">';
        echo "<script> var slidedeckParallaxAdminURL = '{$admin_url}'; </script>";
    }

    function iframe_footer_scripts(){
        $js_path = includes_url( 'js/' );
        echo '<script src="'.SLIDEDECK_PARALLAX_URLPATH.'/jquery-ui.js"></script>';
        echo "<script src='" . $js_path . "underscore.min.js' ></script>";
        echo "<script src='" . $js_path . "backbone.min.js' ></script>";
        echo "<script src='" . SLIDEDECK_PARALLAX_URLPATH . "/jquery.cycle2.min.js' ></script>";
        echo "<script src='" . SLIDEDECK_PARALLAX_URLPATH . "/jquery.parallax.js' ></script>";
        echo "<script src='" . SLIDEDECK_PARALLAX_URLPATH . "/iframe.script.js' ></script>";
        echo "<script src='" . SLIDEDECK_PARALLAX_URLPATH . "/lens.js' ></script>";
    }

    /**
     * Adding the accent-color class to the <a> tags if Twitter
     *
     * @param array $slides Array of Slides
     * @param array $slidedeck The SlideDeck object being rendered
     *
     * @uses SlideDeckLens_Scaffold::is_valid()
     *
     * @return array
     */
    function get_slides( $slides, $slidedeck ){
        if( $this->is_valid( $slidedeck['lens'] ) ){
            foreach( $slides as &$slide ){
                if( $slidedeck['source'] == 'twitter' ){
                    $slide['content'] = preg_replace( '/\<a /', '<a class="accent-color" ', $slide['content'] );
                }
            }
        }
        return $slides;
    }

    function slide_editor_header( $slide ){
        $parallax_type = isset( $slide->meta['_parallax_type'] ) ? $slide->meta['_parallax_type'] : "scroll";
        ?>
        <div class="sdp-slide-checkboxes" >
            <label for="sdp-checkbox-just-effect"><?php _e( 'Scroll Parallax' , 'slidedeck' ); ?></label>
            <input type="radio" name="sdp-checkbox" <?php if( $parallax_type === 'scroll' ) echo 'checked="checked"' ?>  id="sdp-checkbox-just-effect" value="scroll" >
            <label for="sdp-checkbox-layers"><?php _e( 'Mouse Move Parallax' , 'slidedeck' ); ?></label>
            <input type="radio" name="sdp-checkbox" <?php if( $parallax_type === 'mousemove' ) echo 'checked="checked"' ?> id="sdp-checkbox-layers" value="mousemove">
        </div>
        <?php
    }

    function get_data_depth_field( $key, $slide ){
        $data_depth  = intval($this->if_isset( $key , $slide->meta ));
        if( ! $data_depth ) $data_depth = 6;
        ?>
            <span class="sdp-data-depth" for=""><?php _e( 'Movement Depth : ' , 'slidedeck' ); ?></span>
            <select name="<?php echo $key; ?>" id="">
                <?php for( $i = 1 ; $i < 16; $i++ ){ ?>
                    <option value="<?php echo $i; ?>" <?php selected( $data_depth, $i );  ?> ><?php echo $i; ?></option>
                <?php } ?>
            </select>
        <?php
    }

    function add_slide_editor_content( $slide )
    {

        $parallax_type              = $this->if_isset( '_parallax_type' , $slide->meta, 'scroll' );
        $scroll_caption_image_id    = intval($this->if_isset( '_scroll_caption_image' , $slide->meta ));
        $mousemove_layer_1_id       = intval($this->if_isset( '_mousemove_layer_1' , $slide->meta ));
        $mousemove_layer_2_id       = intval($this->if_isset( '_mousemove_layer_2' , $slide->meta ));
        $mousemove_layer_3_id       = intval($this->if_isset( '_mousemove_layer_3' , $slide->meta ));
        $mousemove_caption_image_id = intval($this->if_isset( '_mousemove_caption_image' , $slide->meta ));

        ?>
        <input type="hidden" name="_parallax_type" class="sdp_parallax_type_field" value="<?php echo $parallax_type; ?>" >

        <li class="sdp-scroll-layers sdp-hide" data-slide-id="<?php echo $slide->ID; ?>" >
            <ul>
                <li>
                    <?php $this->get_data_depth_field( '_scroll_data_depth', $slide ); ?>
                </li>
                <li class="<?php if( $scroll_caption_image_id ) echo "sdp_has_thumb" ?>" >
                    <div class="sdp-left">
                        <button class="button sdp-uploader" ><?php _e( 'Upload Caption Image' , 'slidedeck' ); ?></button>
                        <input class="sdp-attachment-id" type="hidden" name="_scroll_caption_image" value="<?php echo $scroll_caption_image_id; ?>" >
                    </div>
                    <div class="sdp-right">
                        <span class="sdp-thumbnail" >
                            <?php echo wp_get_attachment_image( $scroll_caption_image_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdp-url"><?php echo get_the_title( $scroll_caption_image_id ); ?></span>
                        <span class="sdp-cross"></span>
                    </div>
                </li>
            </ul>
        </li>

        <li class="sdp-mouse-move-layers sdp-hide">
            <ul>
                <li>
                    <?php $this->get_data_depth_field( '_mousemove_data_depth' , $slide ); ?>
                </li>
                <li class="<?php if( $mousemove_layer_1_id ) echo "sdp_has_thumb" ?>">
                    <div class="sdp-left">
                        <button class="button sdp-uploader" ><?php _e( 'Upload Layer 1' , 'slidedeck' ); ?></button>
                        <input class="sdp-attachment-id" type="hidden" name="_mousemove_layer_1" value="<?php echo $mousemove_layer_1_id; ?>" >
                    </div>
                    <div class="sdp-right">
                        <span class="sdp-thumbnail" >
                            <?php echo wp_get_attachment_image( $mousemove_layer_1_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdp-url"><?php echo get_the_title( $mousemove_layer_1_id ); ?></span>
                        <span class="sdp-cross"></span>
                    </div>
                </li>
                <li class="<?php if( $mousemove_layer_2_id ) echo "sdp_has_thumb" ?>" >
                    <div class="sdp-left">
                        <button class="button sdp-uploader" ><?php _e( 'Upload Layer 2' , 'slidedeck' ); ?></button>
                        <input class="sdp-attachment-id" type="hidden" name="_mousemove_layer_2" value="<?php echo $mousemove_layer_2_id; ?>">
                    </div>
                    <div class="sdp-right">
                        <span class="sdp-thumbnail" >
                            <?php echo wp_get_attachment_image( $mousemove_layer_2_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdp-url"><?php echo get_the_title( $mousemove_layer_2_id ); ?></span>
                        <span class="sdp-cross"></span>
                    </div>
                </li>
                <li class="<?php if( $mousemove_layer_3_id ) echo "sdp_has_thumb" ?>" >
                    <div class="sdp-left">
                        <button class="button sdp-uploader" ><?php _e( 'Upload Layer 3' , 'slidedeck' ); ?></button>
                        <input class="sdp-attachment-id" type="hidden" name="_mousemove_layer_3" value="<?php echo $mousemove_layer_2_id; ?>" >
                    </div>
                    <div class="sdp-right">
                        <span class="sdp-thumbnail" >
                            <?php echo wp_get_attachment_image( $mousemove_layer_3_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdp-url"><?php echo get_the_title( $mousemove_layer_3_id ); ?></span>
                        <span class="sdp-cross"></span>
                    </div>
                </li>
                <li class="<?php if( $mousemove_caption_image_id ) echo "sdp_has_thumb" ?>" >
                    <div class="sdp-left">
                        <button class="button sdp-uploader" ><?php _e( 'Upload Caption Image' , 'slidedeck' ); ?></button>
                        <input class="sdp-attachment-id" type="hidden" name="_mousemove_caption_image" value="<?php echo $mousemove_caption_image_id; ?>" >
                    </div>
                    <div class="sdp-right">
                        <span class="sdp-thumbnail" >
                            <?php echo wp_get_attachment_image( $mousemove_caption_image_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdp-url"><?php echo get_the_title( $mousemove_caption_image_id ); ?></span>
                        <span class="sdp-cross"></span>
                    </div>
                </li>
            </ul>
        </li>
        <?php
    }

    function update_value( $slide, $data )
    {
        if( ! isset( $data['_parallax_type'] ) || empty( $slide ) || empty( $data ) ) return;

        if( $data['_parallax_type'] === 'scroll' )
        {
            update_post_meta( $slide->ID, "_parallax_type", 'scroll' );

            if( isset( $data['_scroll_caption_image'] ) ){
                update_post_meta( $slide->ID, "_scroll_caption_image", $data['_scroll_caption_image'] );
            }

            if( isset( $data['_scroll_data_depth'] ) ){
                update_post_meta( $slide->ID, "_scroll_data_depth", $data['_scroll_data_depth'] );
            }


        }
        else if( $data['_parallax_type'] === 'mousemove' )
        {
            update_post_meta( $slide->ID, "_parallax_type", 'mousemove' );


            if( isset( $data['_mousemove_data_depth'] ) ){
                update_post_meta( $slide->ID, "_mousemove_data_depth", $data['_mousemove_data_depth'] );
            }

            if( isset( $data['_mousemove_caption_image'] ) ){
                update_post_meta( $slide->ID, "_mousemove_caption_image", $data['_mousemove_caption_image'] );
            }

            if( isset( $data['_mousemove_layer_1'] ) ){
                update_post_meta( $slide->ID, "_mousemove_layer_1", $data['_mousemove_layer_1'] );
            }

            if( isset( $data['_mousemove_layer_2'] ) ){
                update_post_meta( $slide->ID, "_mousemove_layer_2", $data['_mousemove_layer_2'] );
            }

            if( isset( $data['_mousemove_layer_3'] ) ){
                update_post_meta( $slide->ID, "_mousemove_layer_3", $data['_mousemove_layer_3'] );
            }

        }
    }

    function if_isset( $key , $array, $default_value = false ){
        return isset( $array[$key] ) ? $array[$key] : $default_value;
    }

    function add_layers( $content, $slide, $slidedeck )
    {
        $slide_id    = isset( $slide['id'] ) ? $slide['id'] : false;
        $slide_index = $this->slide_count;
        $lens     = isset( $slidedeck['lens'] ) ? $slidedeck['lens'] : false;

        //return;
        if( $lens !== 'parallax' ) return $content;

        $this->slide_count++;

        if( ! $slide_id ) return;

        $scroll_meta_keys = array(
                            '_scroll_caption_image'
                            );

        $mousemove_meta_keys = array(
                        '_mousemove_caption_image' ,
                        '_mousemove_layer_1',
                        '_mousemove_layer_2',
                        '_mousemove_layer_3'
                    );

        $parallax_type = get_post_meta( $slide_id, '_parallax_type', true );

        if( ! $parallax_type ) return;

        $options = $slidedeck['options'];

        $data   = array(
                        'class'                   => "sdp-layers parallax-type-{$parallax_type}" ,
                        'data-parallax-type'      => $parallax_type,
                        'data-continueScrolling'  => $this->if_isset( 'continueScrolling', $options ),
                        'data-autoPlay'           => $this->if_isset( 'autoPlay', $options ),
                        'data-autoPlayInterval'   => $this->if_isset( 'autoPlayInterval', $options ),
                        'data-cycle'              => $this->if_isset( 'cycle', $options ),
                        'data-slideTransition'    => $this->if_isset( 'slideTransition', $options ),
                        'data-speed'              => $this->if_isset( 'speed', $options ),
                        'data-keys'               => $this->if_isset( 'keys', $options ),
                        'data-scroll'             => $this->if_isset( 'scroll', $options ),
                        'data-start'              => $this->if_isset( 'start', $options ),
                        'data-display-nav-arrows' => $this->if_isset( 'display-nav-arrows', $options ),
                        'data-touch'              => $this->if_isset( 'touch', $options ),
                    );

        $data_string = '';

        foreach ( $data as $attr => $value ) {
            $data_string .= "{$attr}='{$value}' ";
        }

        $markup = "<ul {$data_string} >";

        if( $parallax_type === 'scroll' ){

            $data_depth = intval(get_post_meta( $slide_id, '_scroll_data_depth', true ));
            foreach ( $scroll_meta_keys as $key => $meta_key ) {
                $markup .= $this->get_layer( $slide_id, $meta_key, $key, $data_depth );
            }

        }
        else if( $parallax_type === 'mousemove' ){

            $data_depth = intval(get_post_meta( $slide_id, '_mousemove_data_depth', true ));

            foreach ( $mousemove_meta_keys as $key => $meta_key )
            {
                $markup .= $this->get_layer( $slide_id, $meta_key, $key , $data_depth );
            }
        }

        if( $this->is_preview() ){
            $markup .= "<div class='sdp-layer-actions'>";
            $markup .=  "<button class='button sdp-add-opacity' >Add Opacity</button>";
            $markup .=  "<button class='button sdp-save-layers' >Save</button>";
            $markup .= "</div>";
        }

        $markup .= "</ul>";

        return $markup . $content;
    }

    function get_layer( $slide_id, $meta_key, $key, $data_depth )
    {
        $markup = false;
        $key++;
        $default_data_depth =  $key * 6 / 10;
        $depth = $data_depth > 0 ? $default_data_depth * ($data_depth/10) : $default_data_depth;

        $attachment_id    = get_post_meta( $slide_id, $meta_key , true );
        $layer_data       = get_post_meta( $slide_id, $meta_key . '_data' , true );
        $position_x       = isset( $layer_data['cordinates'] ) && ! empty( $layer_data['cordinates'] ) ? $layer_data['cordinates'][0] : false;
        $position_y       = isset( $layer_data['cordinates'] ) && ! empty( $layer_data['cordinates'] ) ? $layer_data['cordinates'][1] : false;
        $data   = array(
                        'class'           => 'layer sdp-slide-layer sdp-scroll-caption-layer' ,
                        'data-depth'      => $depth,
                        'data-selected-depth' => $data_depth,
                        'data-layer'      => $meta_key,
                        'data-z-index'    => $this->if_isset( 'z_index' , $layer_data ),
                        'data-position-x' => $position_x,
                        'data-position-y' => $position_y
                        );

        $data_string = '';

        foreach ( $data as $attr => $value ) {
            $data_string .= "{$attr}='{$value}' ";
        }

        $attachemnt_image = wp_get_attachment_image( $attachment_id, 'full', false );

        if( $attachemnt_image ){
            $markup = "<li {$data_string} >";
            $markup .= $attachemnt_image;
            $markup .= '</li>';
        }

        return $markup;
    }

    function save_layers()
    {
        $layers = $this->if_isset( 'layers' , $_REQUEST );

        $response = "error saving the layer...";

        if( empty( $layers ) ) return;

        foreach ( $layers as $layer )
        {
            $data               = array();
            $slide_id           = $this->if_isset( 'slide_id' , $layer );
            $layer_meta_key     = $this->if_isset( 'layer' , $layer );
            $data['cordinates'] = $this->if_isset( 'per_cordinates' , $layer );
            $data['z_index']    = $this->if_isset( 'z_index' , $layer );

            if( ! $slide_id || ! $layer_meta_key ) continue;

            update_post_meta( $slide_id , $layer_meta_key . '_data' , $data  );

            $response = "Layer Saved..";

        }

        die(json_encode( $response ));
    }

}
