<?php
if (!defined("SLIDEDECK_PIXEL_DIRNAME")) define("SLIDEDECK_PIXEL_DIRNAME", dirname(__FILE__));
if (!defined("SLIDEDECK_PIXEL_URLPATH")) define("SLIDEDECK_PIXEL_URLPATH", trailingslashit(plugins_url()) . 'slidedeck5addon/slidedeck-lenses/' . basename(SLIDEDECK_PIXEL_DIRNAME));
class SlideDeckLens_Pixel extends SlideDeckLens_Scaffold {
    var $options_model = array(
        'Appearance' => array(
            'accentColor' => array(
                'value' => "#3ea0c1"
            ),
            'frame' => array(
                'name' => 'frame',
                'type' => 'select',
                'value' => 'display',
                'values' => array(
                    'display' => 'Desktop',
                    'laptop' => 'Laptop',
                    'tablet' => 'Tablet',
                    'tablet-land' => 'Tablet Landscape',
                    'flat-tablet' => 'Flat Tablet',
                    'flat-tablet-land' => 'Flat Tablet Landscape',
                    'phone' => 'Phone',
                    'phone-land' => 'Phone Landscape',
                    'flat-phone' => 'Flat Phone',
                    'flat-phone-land' => 'Flat Phone Landscape',
                ),
                'label' => 'Frame',
                'description' => "Choose the frame around your SlideDeck",
                'weight' => 40
            ),
            'text-position' => array(
                'name' => 'text-position',
                'type' => 'select',
                'values' => array(
                    'title-pos-top' => 'Top',
                    'title-pos-bottom' => 'Bottom',
                    'title-pos-left' => 'Left',
                    'title-pos-right' => 'Right',
                    'title-pos-fill' => 'Fill Slide'
                                    ),
                'value' => 'title-pos-top',
                'label' => 'Caption Position',
                'description' => "Choose where to place the caption text on the slide",
                'weight' => 50
            ),
            'text-color' => array(
                'name' => 'text-color',
                'type' => 'select',
                'values' => array(
                    'title-dark' => 'Dark',
                    'title-light' => 'Light'
                ),
                'value' => 'title-dark',
                'label' => 'Text Color Variation',
                'weight' => 60
            ),
            'hideSpines' => array(
                'type' => 'hidden',
                'value' => true
            )
        ),
        'Navigation' => array(
            'navigation-type' => array(
                'name' => 'navigation-type',
                'type' => 'select',
                'values' => array(
                    'nav-dots' => 'Dots',
                    'nav-thumb' => 'Thumbnails',
		    'nav-video'=>'Player Controls',
                    'no-nav' => 'Turn Navigation Off'
                ),
                'value' => 'nav-dots',
                'label' => 'Navigation Type',
                'description' => "Note: Dots Navigation Type is limited to a max of 10. If you have more than 10 slides, Thumbnails is better for your users. If player controls option is selected then SlideDeck will be in autoplay mode and end user can now play and pause slider from frontend",
                'weight' => 20
            ),
            'arrow-style' => array(
                'name' => 'arrow-style',
                'type' => 'select',
                'values' => array(
                    'arrowstyle-1' => 'Default',
                    'arrowstyle-2' => 'Pointer Arrow',
                    'arrowstyle-3' => 'Hairline Arrow',
                    'arrowstyle-4' => 'Short Small Arrow',
                    'arrowstyle-5' => 'Circle Hairline Button Arrow',
                    'arrowstyle-6' => 'Circle Play Button Arrow',
                    'arrowstyle-7' => 'Circle Pointer Button Arrow',
                    'arrowstyle-8' => 'Circle Play Arrow',
                    'arrowstyle-9' => 'Circle Pointer Arrow',
                    'arrowstyle-11' => 'Dark Default',
                    'arrowstyle-12' => 'Dark Pointer Arrow',
                    'arrowstyle-13' => 'Dark Hairline Arrow',
                    'arrowstyle-14' => 'Dark Short Small Arrow',
                    'arrowstyle-15' => 'Dark Circle Hairline Button Arrow',
                    'arrowstyle-16' => 'Dark Circle Play Button Arrow',
                    'arrowstyle-17' => 'Dark Circle Pointer Button Arrow',
                    'arrowstyle-18' => 'Dark Circle Play Arrow',
                    'arrowstyle-19' => 'Dark Circle Pointer Arrow'
                ),
                'value' => 'arrowstyle-7',
                'label' => 'Arrow Style',
                'description' => "Pick an arrow style that best matches your website's design.",
                'weight' => 40,
                'interface' => array(
                    'type' => 'thumbnails-flyout',
                    'values' => array(
                        'arrowstyle-1' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_1.thumb.png',
                        'arrowstyle-2' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_2.thumb.png',
                        'arrowstyle-3' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_3.thumb.png',
                        'arrowstyle-4' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_4.thumb.png',
                        'arrowstyle-5' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_5.thumb.png',
                        'arrowstyle-6' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_6.thumb.png',
                        'arrowstyle-7' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_7.thumb.png',
                        'arrowstyle-8' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_8.thumb.png',
                        'arrowstyle-9' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_9.thumb.png',
                        'arrowstyle-11' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_11.thumb.png',
                        'arrowstyle-12' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_12.thumb.png',
                        'arrowstyle-13' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_13.thumb.png',
                        'arrowstyle-14' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_14.thumb.png',
                        'arrowstyle-15' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_15.thumb.png',
                        'arrowstyle-16' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_16.thumb.png',
                        'arrowstyle-17' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_17.thumb.png',
                        'arrowstyle-18' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_18.thumb.png',
                        'arrowstyle-19' => '/../slidedeck5addon/slidedeck-lenses/pixel/images/nav-arrows/arrowstyle_19.thumb.png',
                    )
                )
            ),
            'arrowStyleBackground' => array(
                'type' => 'radio',
                'data' => "boolean",
                'value' => false,
                'label' => "Turn off Background",
                'description' => "Allow users to turn off the navigation arrows background color",
                'weight' => 40
            ),
            'arrowStyleColor' => array(
                'type' => "text",
                'data' => "string",
                'attr' => array(
                    'class' => "color-picker",
                    'size' => 7
                ),
                'value' => "#000",
                'label' => "Arrow Style Color",
                'description' => "Pick a background color for the navigation arrows.",
                'weight' => 40
            ),
            'nav-arrow-style' => array(
                'name' => 'nav-arrow-style',
                'type' => 'select',
                'values' => array(
                    'nav-arrow-style-1' => 'Button',
                    'nav-arrow-style-2' => 'Arrow'
                ),
                'value' => 'nav-arrow-style-1',
                'label' => 'Thumbnail Arrow Style',
                'weight' => 50,
                'description' => "Pick an arrow style for the Thumbnail Navigation"
            ),
        )
    );

    function __construct(){
        parent::__construct();

        add_filter( "{$this->namespace}_get_slides", array( &$this, "slidedeck_get_slides" ), 11, 2 );
        // added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_pixel", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_pixel", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );

        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_pixel", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_pixel", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );
        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_pixel", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_pixel", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_pixel", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_pixel", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_pixel", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core
    }
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {

        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {

        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#' . $slidedeck_unique_id . '-frame img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#' . $slidedeck_unique_id . '-frame").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {

        $html .= '<dl id="' . $slidedeck_unique_id . '" class="' . implode( " ", $slidedeck_classes ) . '" style="' . $slidedeck_styles_str . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {

        $html.= '</dl>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {

        $html .= '<div id="' . $slidedeck_unique_id . '-frame" class="' . implode( " ", $frame_classes ) . '" style="' . $frame_styles_str . '" data-sd2-lazy-load-padding="' . $slidedeck_lazy_load_padding . '" data-sd3-image_protection="' . $slidedeck_image_protection . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '<a class="deck-navigation horizontal prev" href="#prev-horizontal"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation horizontal next" href="#next-horizontal"><span>Next</span></a>';
        $html .= '<a class="deck-navigation vertical prev" href="#prev-vertical"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation vertical next" href="#next-vertical"><span>Next</span></a>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {

        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {

        if( $slide['type'] == "video" ){
		$output .= '<dd itemprop="video" itemscope itemtype="http://schema.org/VideoObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
	} else {
            $output .= '<dd itemscope="" itemtype="http://schema.org/ImageObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
	}
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {

        $output .= "</dd>";
        return $output;
    }

    /**
     * Adding the accent-color class to the <a> tags if Twitter
     *
     * @param array $slides Array of Slides
     * @param array $slidedeck The SlideDeck object being rendered
     *
     * @uses SlideDeckLens_Scaffold::is_valid()
     *
     * @return array
     */
    function slidedeck_get_slides( $slides, $slidedeck ){
        if( $this->is_valid( $slidedeck['lens'] ) ){

            foreach( $slides as &$slide ){
                if( $slidedeck['source'] == 'twitter' ){
                    $slide['content'] = preg_replace( '/\<a /', '<a class="accent-color" ', $slide['content'] );
                }
            }
        }
        return $slides;
    }

    function slidedeck_render_slidedeck_before($html, $slidedeck){
        if( $this->is_valid( $slidedeck['lens'] ) ) {
	        switch( $slidedeck['options']['frame'] ){
		        case 'display' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:612px;height:478px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:5%;left:9%;bottom:35%;right:9%;">';
			        break;
		        case 'laptop' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:645px;height:458px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:7%;left:12%;right:12%;">';
			        break;
		        case 'tablet' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:500px;height:681px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:8%;left:10%;right:10%;">';
			        break;
		        case 'tablet-land' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:842px;height:600px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:6%;left:12%;right:13%;">';
			        break;
		        case 'flat-tablet' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:500px;height:681px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:8%;left:10%;right:10%;">';
			        break;
		        case 'flat-tablet-land' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:842px;height:600px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:6%;left:12%;right:13%;">';
			        break;
		        case 'phone' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:386px;height:663px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:15%;left:17%;right:17%;">';
			        break;
		        case 'phone-land' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:666px;height:329px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:10%;left:15.5%;right:16%;">';
			        break;
		        case 'flat-phone' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:386px;height:663px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:15%;left:17%;right:17%;">';
			        break;
		        case 'flat-phone-land' :
			        $html .= '<img src="'.SLIDEDECK_PIXEL_URLPATH.'/images/frame/'.$slidedeck["options"]["frame"].'.png" style="position:absolute;width:666px;height:329px;">';
			        $html .= '<div class="sd-wrapper" style="position:absolute;top:10%;left:15.5%;right:16%;">';
			        break;
		        default :
			        $html .= '<div class="sd-wrapper">';
	        }


        }
        return $html;
    }

    function slidedeck_render_slidedeck_after($html, $slidedeck){
        if( $this->is_valid( $slidedeck['lens'] ) ) {
            $html .= '</div>';
        }
        return $html;
    }

    /**
     * Add appropriate classes for this Lens to the SlideDeck frame
     *
     * @param array $slidedeck_classes Classes to be applied
     * @param array $slidedeck The SlideDeck object being rendered
     *
     * @return array
     */

    function slidedeck_frame_classes( $slidedeck_classes, $slidedeck ) {
        if( $this->is_valid( $slidedeck['lens'] ) ) {

            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['navigation-type'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['frame'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['text-position'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['text-color'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['show-title'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['nav-arrow-style'];
            $slidedeck_classes[] = $this->prefix . $slidedeck['options']['arrow-style'];


        }

        return $slidedeck_classes;
    }

    function slidedeck_dimensions( &$width, &$height, &$outer_width, &$outer_height, &$slidedeck ) {
        global $SlideDeckPlugin;
        if( $this->is_valid( $slidedeck['lens'] ) ) {

            $og_w = $width;
            $og_h = $height;
            $og_ow = $outer_width;
            $og_oh = $outer_height;

            $size = $SlideDeckPlugin->SlideDeck->get_closest_size($slidedeck);

            switch( $slidedeck['options']['frame'] ){
                case 'display':
                    $width = $og_w - 24;
                    $height = $og_h - 196;
                    break;
	            case 'laptop':
		            $width = $og_w - 24;
		            $height = $og_h - 140;
		            break;
	            case 'tablet':
		            $width = $og_w - 24;
		            $height = $og_h - 157;
		            break;
	            case 'tablet-land':
		            $width = $og_w - 24;
		            $height = $og_h - 128;
		            break;
	            case 'flat-tablet':
		            $width = $og_w - 24;
		            $height = $og_h - 157;
		            break;
	            case 'flat-tablet-land':
		            $width = $og_w - 24;
		            $height = $og_h - 128;
		            break;
	            case 'phone':
		            $width = $og_w - 24;
		            $height = $og_h - 210;
		            break;
	            case 'phone-land':
		            $width = $og_w;
		            $height = $og_h - 74;
		            break;
	            case 'flat-phone':
		            $width = $og_w - 24;
		            $height = $og_h - 208;
		            break;
	            case 'flat-phone-land':
		            $width = $og_w - 24;
		            $height = $og_h - 74;
		            break;
	            default:
                    break;
            }
        }
    }
}
