<?php
class SlideDeckLens_Titles extends SlideDeckLens_Scaffold {
	var $dates = array();
	var $titles = array();
	
    var $options_model = array(
        'Appearance' => array(
            'accentColor' => array(
                'value' => "#fff"
            ),
            'titleFont' => array(
                'value' => 'oswald'
            ),
            'bodyFont' => array(
                'value' => 'crimson_text'
            ),
            'hideSpines' => array(
                'type' => 'hidden',
                'value' => true
            ),
        ),
        'Content' => array(
            'show-excerpt' => array(
                'type' => 'hidden',
                'value' => false
            ),
            'show-readmore' => array(
                'type' => 'hidden',
                'value' => false
            ),
            'excerptLengthWithImages' => array(
                'type' => 'hidden',
                'value' => false
            ),
            'excerptLengthWithoutImages' => array(
                'type' => 'hidden',
                'value' => false
            ),
            'show-author-avatar' => array(
                'type' => 'hidden',
                'value' => false
            ),
        ),
		'Navigation' => array(
			'navigation-type' => array(
				'name' => 'navigation-type',
				'type' => 'select',
				'values' => array(
                                        'nav-text' => 'Text',
					'nav-thumbnails' => 'Thumbnails',
					'nav-dots' => 'Dots',
					'no-nav' => 'Turn Navigation Off'
				),
				'value' => 'nav-text',
				'label' => 'Navigation Type',
				'weight' => 49
			),
            'thumbnailHeight' => array(
                'type' => 'select',
                'data' => "integer",
                'values' => array(
                    10 => "10% of width",
                    15 => "15% of width",
                    20 => "20% of width",
                    25 => "25% of width",
                    30 => "30% of width",
                    35 => "35% of width",
                    40 => "40% of width",
                    45 => "45% of width",
                    50 => "50% of width",
                ),
                'value' => 50,
                'label' => "Thumbnail height",
                'description' => "Adjusts the intrinsic ratio of the thumbnails",
                'interface' => array(
                    'type' => 'slider',
                    'min' => 10,
                    'max' => 50,
                    'minLabel' => "Short",
                    'maxLabel' => "Tall",
                    'step' => 5
                ),
                'weight' => 48
            ),
        ),
        'Playback' => array(
        	'titleTransition' => array(
                'type' => 'select',
                'data' => "string",
                'values' => array(
                    'stack' => "Card Stack",
                    'shake' => "Shake",
                    'fade' => "Cross-fade",
                    'flipHorizontal' => "Flip Horizontal (CSS3)",
                    'flip' => "Flip Vertical (CSS3)",
                    'slide' => "Slide"
                ),
                'value' => 'slide',
                'label' => "Title Transition",
                'description' => "Choose an animation for transitioning of Titles (CSS3 transitions may not work well with videos or in all browsers)",
                'subtext' => "Not all transitions will work with videos or in older browsers. \"Slide\" transition is the only working option for vertical navigation.",
                'weight' => 40
            ),
        ),
    );
    function __construct(){
        parent::__construct();
         // added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_titles", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_titles", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );
        
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_titles", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_titles", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );
        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_titles", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_titles", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_titles", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_titles", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_titles", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core
    }
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {
        
        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {
        
        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#' . $slidedeck_unique_id . '-frame img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#' . $slidedeck_unique_id . '-frame").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {
        
        $html .= '<dl id="' . $slidedeck_unique_id . '" class="' . implode( " ", $slidedeck_classes ) . '" style="' . $slidedeck_styles_str . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {
        
        $html.= '</dl>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {
        
        $html .= '<div id="' . $slidedeck_unique_id . '-frame" class="' . implode( " ", $frame_classes ) . '" style="' . $frame_styles_str . '" data-sd2-lazy-load-padding="' . $slidedeck_lazy_load_padding . '" data-sd3-image_protection="' . $slidedeck_image_protection . '">';
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '<a class="deck-navigation horizontal prev" href="#prev-horizontal"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation horizontal next" href="#next-horizontal"><span>Next</span></a>';
        $html .= '<a class="deck-navigation vertical prev" href="#prev-vertical"><span>Previous</span></a>';
        $html .= '<a class="deck-navigation vertical next" href="#next-vertical"><span>Next</span></a>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {
        
        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {
        
// $output .= "<dt". ( (!empty( $spine_classes ) ) ? ' class="'. implode( " ", $spine_classes ) . '"' :'') . ( (!empty( $spine_styles ) ) ? ' style="'. $spine_styles . '"' :'') .">{$slide_title}</dt>";
        if( $slide['type'] == "video" ){
            $output .= '<dd itemprop="video" itemscope itemtype="http://schema.org/VideoObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        } else {
            $output .= '<dd itemscope="" itemtype="http://schema.org/ImageObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        }
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {
        
        $output .= "</dd>";
        return $output;
    }
    function slidedeck_dimensions( &$width, &$height, &$outer_width, &$outer_height, &$slidedeck ) {
    	global $SlideDeckPlugin;
    	if( $this->is_valid( $slidedeck['lens'] ) ) {
			switch( $slidedeck['options']['navigation-type'] ) {
				case 'nav-thumbnails':
                    
				break;
				case 'nav-dots':
                    
				break;
			}
		}
	}

   	/**
     * Add appropriate classes for this Lens to the SlideDeck frame
     * 
     * @param array $slidedeck_classes Classes to be applied
     * @param array $slidedeck The SlideDeck object being rendered
     * 
     * @return array
     */
    function slidedeck_frame_classes( $slidedeck_classes, $slidedeck ) {
        global $SlideDeckPlugin;
        
        if( $this->is_valid( $slidedeck['lens'] ) ) {
            $size = $SlideDeckPlugin->SlideDeck->get_closest_size($slidedeck);
            
            if( $size == 'small' && ( $slidedeck['options']['navigation-type'] == 'nav-thumbnails' ) ) {
                $slidedeck_classes[] = $this->prefix . 'nav-dots';
            }else{
            	$slidedeck_classes[] = $this->prefix . $slidedeck['options']['navigation-type'];
            }
            
        	$slidedeck_classes[] = $this->prefix . 'arrowstyle-2';
           	$slidedeck_classes[] = $this->prefix . 'thumbnail-height-' . $slidedeck['options']['thumbnailHeight'];
            
        }
        return $slidedeck_classes;
    }
}
