<?php

if (!defined("SLIDEDECK_TRANSITIONPRO_DIRNAME")) define("SLIDEDECK_TRANSITIONPRO_DIRNAME", dirname(__FILE__));
if (!defined("SLIDEDECK_TRANSITIONPRO_URLPATH")) define("SLIDEDECK_TRANSITIONPRO_URLPATH", trailingslashit(plugins_url()) . 'slidedeck5addon/slidedeck-lenses/' . basename(SLIDEDECK_TRANSITIONPRO_DIRNAME));
if (!defined("SLIDEDECK_TRANSITIONPRO_VERSION")) define("SLIDEDECK_TRANSITIONPRO_VERSION", "1.0.0");

class SlideDeckLens_Transitionpro extends SlideDeckLens_Scaffold
{
    public $slide_count;
    var $options_model = array(

		'Navigation' => array(
                        'display-navigation' => array(
                            'type' => 'radio',
                            'data' => "boolean",
                            'value' => false,
                            'label' => "Show Slide Controls",
                            'description' => "Adjust when slide controls are shown to your visitors",
                            'weight' => 1
                        ),
			'navigation-type' => array(
                            'name' => 'navigation-type',
                            'type' => 'select',
                            'values' => array(
                                'nav-dots' => 'Dots',
                                'nav-thumb' => 'Thumbnails',
                                'nav-number'=>'Numbers',
                                'no-nav' => 'Turn Navigation Off'
                            ),
                            'value' => 'nav-dots',
                            'label' => 'Navigation Type',
                            'description' => "Note: Dots Navigation Type is limited to a max of 10. If you have more than 10 slides, Thumbnails is better for your users. If player controls option is selected then SlideDeck will be in autoplay mode and end user can now play and pause slider from frontend",
                            'weight' => 20
                        ),
		),
        'Playback' => array(
                'progressBar' => array(
                    'type' => 'radio',
                    'data' => "boolean",
                    'value' => false,
                    'label' => "Progress Bar",
                    'description' => "Set the Progress Bar to display",
                    'weight' => 20
                ),
            ),

	);
    function __construct(){
        parent::__construct();

        add_filter( "{$this->namespace}_iframe_scripts", array( $this, 'slidedeck_iframe_scripts' ), 999, 2 );

        add_filter( "{$this->namespace}_get_slides", array( &$this, "get_slides" ), 11, 2 );
        // added filters to remove lens code from the core
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_before_transitionpro", array( &$this, "slidedeck_render_slidedeck_wrapper_content_before" ), 12, 6 );
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_content_after_transitionpro", array( &$this, "slidedeck_render_slidedeck_wrapper_content_after" ), 12, 2 );

        add_filter( "{$this->namespace}_render_slidedeck_wrapper_before_transitionpro", array( &$this, "slidedeck_render_slidedeck_wrapper_before" ), 13, 8);
        add_filter( "{$this->namespace}_render_slidedeck_wrapper_after_transitionpro", array( &$this, "slidedeck_render_slidedeck_wrapper_after" ), 13, 1 );

        add_filter( "{$this->namespace}_render_dt_and_dd_elements_before_transitionpro", array( &$this, "slidedeck_render_dt_and_dd_elements_before" ), 14, 7 );
        add_filter( "{$this->namespace}_render_dt_and_dd_elements_after_transitionpro", array( &$this, "slidedeck_render_dt_and_dd_elements_after" ), 14, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_navigation_content_transitionpro", array( &$this, "slidedeck_render_slidedeck_navigation_content" ), 15, 1 );

        add_filter( "{$this->namespace}_render_slidedeck_footer_scripts_transitionpro", array( &$this, "slidedeck_render_slidedeck_footer_scripts" ), 12, 5 );
        add_filter( "{$this->namespace}_render_slidedeck_image_protection_transitionpro", array( &$this, "slidedeck_render_slidedeck_image_protection" ), 12, 3 );
        // end of filters added to remove lens code from the core
        add_action( "{$this->namespace}_slide_editor_header" , array( $this , 'slide_editor_header' ) );
        add_action( "{$this->namespace}_after_slide_editor_field" , array( $this , 'add_slide_editor_content' ) , 11 , 1 );

        add_action( "slidedeck_transitionpro_fields_update", array( $this , 'update_value' ) , 10, 2 );
        add_filter( "slidedeck_slide_content" , array( $this , 'add_layers' ) , 9, 3 ); //Problem found

        add_action( 'slidedeck_iframe_header', array( $this , 'enqueue_iframe_scripts' ) );

        add_action( 'slidedeck_iframe_footer', array( $this , 'iframe_footer_scripts' ) );

        add_action( 'admin_enqueue_scripts' , array( &$this, 'enqueue_admin_scripts' ) );

        add_action( 'wp_ajax_sdtp_save_layers' , array( $this , 'save_layers' ) );

        add_action( 'wp_enqueue_scripts', array( $this , 'front_scripts' ) );

        add_filter( "{$this->namespace}_options_model", array( $this, 'default_options' ), 20, 2 );

    }
    // --- Dhananjay
    function slidedeck_render_slidedeck_footer_scripts($footer_scripts, $slidedeck_unique_id, $jquery_cycle_options, $javascript_options, $vertical_scripts ) {

        $footer_scripts .= '<script type="text/javascript">jQuery("#' . $slidedeck_unique_id . '").slidedeck( ' . json_encode( $javascript_options ) . ' )' . $vertical_scripts . ';</script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_image_protection($footer_scripts, $slidedeck_unique_id, $id ) {

        $footer_scripts .= '<script type="text/javascript">
                    jQuery("#slidedeck-'. $id.' img").bind("contextmenu", function(e){
                    var defaultImageProtection = jQuery("#slidedeck-' . $id . '").data("sd3-image_protection");
                    if(defaultImageProtection == "0")
                        return true;
                    else
                        return false;
                    });
                 </script>';
        return $footer_scripts;
    }
    function slidedeck_render_slidedeck_wrapper_content_before($html, $slidedeck, $slidedeck_unique_id, $id, $slidedeck_styles_str, $slidedeck_classes ) {

        $html .= "<ul id='slidedeck-transitionpro-lens-{$id}'  class='slidedeck-transitionpro-lens lens-transitionpro' >";
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_content_after($html) {

        $html.= '</ul>';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_before($html, $slidedeck, $slidedeck_unique_id, $id, $frame_styles_str, $slidedeck_image_protection, $frame_classes, $slidedeck_lazy_load_padding ) {

        $html .= "<div id='{$slidedeck_unique_id}' class='slidedeck-transitionpro-null'></div>";
        $html .= "<div id='slidedeck-{$id}' style='" . $frame_styles_str . "' class='slidedeck-transitionpro sdtp-loading skitter skitter-large' data-sd3-image_protection='". $slidedeck_image_protection ."'>";
        return $html;
    }
    function slidedeck_render_slidedeck_navigation_content($html) {
        $html .= '';
        return $html;
    }
    function slidedeck_render_slidedeck_wrapper_after($html) {

        $html.= '</div>';
        return $html;
    }
    function slidedeck_render_dt_and_dd_elements_before($output, $slidedeck, $slide, $slide_id, $spine_classes, $spine_styles, $slide_title) {
        //wp_enqueue_script( 'cycle-all' );
        if( $slide['type'] == "video" ){
            $output .= '<li itemscope="" itemtype="http://schema.org/VideoObject" style="' . $slide['styles'] . '" class="' . implode( " ", $slide['classes'] ) . '" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'" >';
        } else {
            $output .= '<li itemscope="" itemtype="http://schema.org/ImageObject" class="slide" data-thumbnail-src="' . $slide['thumbnail'] . '" data-slide-id="'.$slide_id.'"  >';
        }
        return $output;
    }
    function slidedeck_render_dt_and_dd_elements_after($output) {

        $output .= "</li>";
        return $output;
    }
    // End of Code --- Dhananjay
    function default_options( $default_options, $params ) {

        if( isset( $params['lens'] ) && 'transitionpro' == $params['lens'] ) {
            /*
            $default_options['Navigation']['navigation-type']['values'] = array(
                'number-nav' => __( 'Numbers' , 'supernova' ),
		'dot-nav' => __( 'Dots' , 'supernova' ),
                'nav-thumb' => __( 'Thumbnails' , 'supernova' ),
                'no-nav' => __( 'Turn Navigation Off' , 'supernova' )
            );
             *
             */
            $default_options['Playback']['slideTransition']['values'] = array(
                'blind'       => __( 'Blind' , 'supernova' ),
                    'blindHeight' => __( 'Blind Height' , 'supernova' ),
                    'blindWidth' => __( 'Blind Width' , 'supernova' ),
                    'block' => __( 'Block' , 'supernova' ),
                    'circles' => __( 'Circles' , 'supernova' ),
                    'circlesInside' => __( 'Circles Inside' , 'supernova' ),
                    'circlesRotate' => __( 'Circles Rotate' , 'supernova' ),
                    'cube' => __( 'Cube' , 'supernova' ),
                    'cubeHide' => __( 'Cube Hide' , 'supernova' ),
                    'cubeRandom' => __( 'Cube Random' , 'supernova' ),
                    'cubeShow' => __( 'Cube Show' , 'supernova' ),
                    'cubeSize' => __( 'Cube Size' , 'supernova' ),
                    'cubeSpread' => __( 'Cube Sperad' , 'supernova' ),
                    'cubeStop' => __( 'Cube Stop' , 'supernova' ),
                    'cut' => __( 'Cut' , 'supernova' ),
                    'directionBottom' => __( 'Direction Bottom' , 'supernova' ),
                    'directionLeft' => __( 'Direction Left' , 'supernova' ),
                    'directionRight' => __( 'Direction Right' , 'supernova' ),
                    'directionTop' => __( 'Direction Top' , 'supernova' ),
                    'downBars' => __( 'Down Bars' , 'supernova' ),
                    'fade' => __( 'Fade' , 'supernova' ),
                    'fadeFour' => __( 'Fade Four' , 'supernova' ),
                    'glassCube' => __( 'Glass Cube' , 'supernova' ),
                    'hideBars' => __( 'Hide Bars' , 'supernova' ),
                    'horizontal' => __( 'Horizontal' , 'supernova' ),
                    'paralell' => __( 'Parallel' , 'supernova' ),
                    'showBars' => __( 'Show Bars' , 'supernova' ),
                    'showBarsRandom' => __( 'Show Bars Random' , 'supernova' ),
                    'swapBars' => __( 'Swap Bars' , 'supernova' ),
                    'swapBarsBack' => __( 'Swap Bars Back' , 'supernova' ),
                    'swapBlocks' => __( 'Swap Blocks' , 'supernova' ),
                    'tube' => __( 'Tube' , 'supernova' ),
                    'upBars' => __( 'Up Bars' , 'supernova' ),
            );
        }

        return $default_options;
    }

    function front_scripts(){
        wp_register_script( 'sdtp-easing' , SLIDEDECK_TRANSITIONPRO_URLPATH . '/jquery.easing.1.3.js', array('jquery'), SLIDEDECK_TRANSITIONPRO_VERSION , true );
        wp_register_script( 'sdtp-transitionpro' , SLIDEDECK_TRANSITIONPRO_URLPATH . '/jquery.skitter.js', array('jquery'), SLIDEDECK_TRANSITIONPRO_VERSION , true  );
        wp_enqueue_script( 'sdtp-transitionpro' );
        wp_enqueue_script( 'sdtp-easing' );
        // wp_enqueue_script( 'scrolling-js' );
    }

    /**
     *  function remove unused scripts from backend preview
     * @param type $footer_scripts
     * @param type $slidedeck
     * @return type
     */
    function slidedeck_iframe_scripts( $footer_scripts, $slidedeck )
    {
        if ( $this->is_valid( $slidedeck['lens'] ) ) {
            return $footer_scripts;
        } else {
            return $footer_scripts;
        }
    }

    function is_preview(){
        return isset( $_GET['action'] ) && $_GET['action'] === 'slidedeck_preview_iframe';
    }

    function enqueue_admin_scripts(){
        if( isset( $_GET['page'] ) && $_GET['page'] === 'slidedeck.php' ){
            wp_enqueue_media();
            wp_enqueue_script("{$this->namespace}-transitionpro-easing-js", SLIDEDECK_TRANSITIONPRO_URLPATH . '/jquery.easing.1.3.js');
            wp_enqueue_script("{$this->namespace}-transitionpro-js", SLIDEDECK_TRANSITIONPRO_URLPATH . '/jquery.skitter.js');
            wp_enqueue_script(  "{$this->namespace}-transitionpro-admin-js", SLIDEDECK_TRANSITIONPRO_URLPATH . '/lens.admin.js' );
            wp_enqueue_style(  "{$this->namespace}-transitionpro-admin-css", SLIDEDECK_TRANSITIONPRO_URLPATH . '/lens.admin.css' );
        }
    }

    function enqueue_iframe_scripts()
    {
        $admin_url = admin_url( 'admin-ajax.php' );
        echo '<link rel="stylesheet" type="text/css" href="'.SLIDEDECK_TRANSITIONPRO_URLPATH.'/lens.admin.css">';
        echo "<script> var slidedeckTransitionproAdminURL = '{$admin_url}'; </script>";
    }

    function iframe_footer_scripts(){
        $js_path = includes_url( 'js/' );
        echo '<script src="'.SLIDEDECK_TRANSITIONPRO_URLPATH.'/jquery-ui.js"></script>';
        echo '<script src="'.SLIDEDECK_TRANSITIONPRO_URLPATH.'/jquery.easing.1.3.js"></script>';



        echo "<script src='" . SLIDEDECK_TRANSITIONPRO_URLPATH . "/jquery.skitter.js' ></script>";
         echo "<script src='" . SLIDEDECK_TRANSITIONPRO_URLPATH . "/iframe.script.js' ></script>";
        echo "<script src='" . SLIDEDECK_TRANSITIONPRO_URLPATH . "/lens.js' ></script>";

    }

    /**
     * Adding the accent-color class to the <a> tags if Twitter
     *
     * @param array $slides Array of Slides
     * @param array $slidedeck The SlideDeck object being rendered
     *
     * @uses SlideDeckLens_Scaffold::is_valid()
     *
     * @return array
     */
    function get_slides( $slides, $slidedeck ){
        if( $this->is_valid( $slidedeck['lens'] ) ){
            foreach( $slides as &$slide ){
                if( $slidedeck['source'] == 'twitter' ){
                    $slide['content'] = preg_replace( '/\<a /', '<a class="accent-color" ', $slide['content'] );
                }
            }
        }
        return $slides;
    }

    function slide_editor_header( $slide ){
        $transitionpro_type = isset( $slide->meta['_transitionpro_type'] ) ? $slide->meta['_transitionpro_type'] : "scroll";
        ?>
<!--
        <div class="sdtp-slide-checkboxes" >
            <label for="sdtp-checkbox-just-effect"><?php _e( 'Scroll Transitionpro' , 'slidedeck' ); ?></label>
            <input type="radio" name="sdtp-checkbox" <?php if( $transitionpro_type === 'scroll' ) echo 'checked="checked"' ?>  id="sdtp-checkbox-just-effect" value="scroll" >
            <label for="sdtp-checkbox-layers"><?php _e( 'Mouse Move Transitionpro' , 'slidedeck' ); ?></label>
            <input type="radio" name="sdtp-checkbox" <?php if( $transitionpro_type === 'mousemove' ) echo 'checked="checked"' ?> id="sdtp-checkbox-layers" value="mousemove">
        </div>
-->
        <?php
    }

    function get_data_depth_field( $key, $slide ){
        $data_depth  = intval($this->if_isset( $key , $slide->meta ));
        if( ! $data_depth ) $data_depth = 6;
        ?>
            <span class="sdtp-data-depth" for=""><?php _e( 'Movement Depth : ' , 'slidedeck' ); ?></span>
            <select name="<?php echo $key; ?>" id="">
                <?php for( $i = 1 ; $i < 16; $i++ ){ ?>
                    <option value="<?php echo $i; ?>" <?php selected( $data_depth, $i );  ?> ><?php echo $i; ?></option>
                <?php } ?>
            </select>
        <?php
    }

    function add_slide_editor_content( $slide )
    {

        $transitionpro_type              = $this->if_isset( '_transitionpro_type' , $slide->meta, 'scroll' );
        $t_scroll_caption_image_id    = intval($this->if_isset( '_t_scroll_caption_image' , $slide->meta ));
        $t_mousemove_layer_1_id       = intval($this->if_isset( '_t_mousemove_layer_1' , $slide->meta ));
        $t_mousemove_layer_2_id       = intval($this->if_isset( '_t_mousemove_layer_2' , $slide->meta ));
        $t_mousemove_layer_3_id       = intval($this->if_isset( '_t_mousemove_layer_3' , $slide->meta ));
        $t_mousemove_caption_image_id = intval($this->if_isset( '_t_mousemove_caption_image' , $slide->meta ));

        ?>
        <input type="hidden" name="_transitionpro_type" class="sdtp_transitionpro_type_field" value="<?php echo $transitionpro_type; ?>" >

        <li class="sdtp-scroll-layers sdtp-hide" data-slide-id="<?php echo $slide->ID; ?>" >
            <ul>
                <li>
                    <?php $this->get_data_depth_field( '_scroll_data_depth', $slide ); ?>
                </li>
                <li class="<?php if( $t_scroll_caption_image_id ) echo "sdtp_has_thumb" ?>" >
                    <div class="sdtp-left">
                        <button class="button sdtp-uploader" ><?php _e( 'Upload Caption Image' , 'slidedeck' ); ?></button>
                        <input class="sdtp-attachment-id" type="hidden" name="_t_scroll_caption_image" value="<?php echo $t_scroll_caption_image_id; ?>" >
                    </div>
                    <div class="sdtp-right">
                        <span class="sdtp-thumbnail" >
                            <?php echo wp_get_attachment_image( $t_scroll_caption_image_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdtp-url"><?php echo get_the_title( $t_scroll_caption_image_id ); ?></span>
                        <span class="sdtp-cross"></span>
                    </div>
                </li>
            </ul>
        </li>

        <li class="sdtp-mouse-move-layers sdtp-hide">
            <ul>
                <li>
                    <?php $this->get_data_depth_field( '_t_mousemove_data_depth' , $slide ); ?>
                </li>
                <li class="<?php if( $t_mousemove_layer_1_id ) echo "sdtp_has_thumb" ?>">
                    <div class="sdtp-left">
                        <button class="button sdtp-uploader" ><?php _e( 'Upload Layer 1' , 'slidedeck' ); ?></button>
                        <input class="sdtp-attachment-id" type="hidden" name="_t_mousemove_layer_1" value="<?php echo $t_mousemove_layer_1_id; ?>" >
                    </div>
                    <div class="sdtp-right">
                        <span class="sdtp-thumbnail" >
                            <?php echo wp_get_attachment_image( $t_mousemove_layer_1_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdtp-url"><?php echo get_the_title( $t_mousemove_layer_1_id ); ?></span>
                        <span class="sdtp-cross"></span>
                    </div>
                </li>
                <li class="<?php if( $t_mousemove_layer_2_id ) echo "sdtp_has_thumb" ?>" >
                    <div class="sdtp-left">
                        <button class="button sdtp-uploader" ><?php _e( 'Upload Layer 2' , 'slidedeck' ); ?></button>
                        <input class="sdtp-attachment-id" type="hidden" name="_t_mousemove_layer_2" value="<?php echo $t_mousemove_layer_2_id; ?>">
                    </div>
                    <div class="sdtp-right">
                        <span class="sdtp-thumbnail" >
                            <?php echo wp_get_attachment_image( $t_mousemove_layer_2_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdtp-url"><?php echo get_the_title( $t_mousemove_layer_2_id ); ?></span>
                        <span class="sdtp-cross"></span>
                    </div>
                </li>
                <li class="<?php if( $t_mousemove_layer_3_id ) echo "sdtp_has_thumb" ?>" >
                    <div class="sdtp-left">
                        <button class="button sdtp-uploader" ><?php _e( 'Upload Layer 3' , 'slidedeck' ); ?></button>
                        <input class="sdtp-attachment-id" type="hidden" name="_t_mousemove_layer_3" value="<?php echo $t_mousemove_layer_2_id; ?>" >
                    </div>
                    <div class="sdtp-right">
                        <span class="sdtp-thumbnail" >
                            <?php echo wp_get_attachment_image( $t_mousemove_layer_3_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdtp-url"><?php echo get_the_title( $t_mousemove_layer_3_id ); ?></span>
                        <span class="sdtp-cross"></span>
                    </div>
                </li>
                <li class="<?php if( $t_mousemove_caption_image_id ) echo "sdtp_has_thumb" ?>" >
                    <div class="sdtp-left">
                        <button class="button sdtp-uploader" ><?php _e( 'Upload Caption Image' , 'slidedeck' ); ?></button>
                        <input class="sdtp-attachment-id" type="hidden" name="_t_mousemove_caption_image" value="<?php echo $t_mousemove_caption_image_id; ?>" >
                    </div>
                    <div class="sdtp-right">
                        <span class="sdtp-thumbnail" >
                            <?php echo wp_get_attachment_image( $t_mousemove_caption_image_id , 'thumbnail' ); ?>
                        </span>
                        <span class="sdtp-url"><?php echo get_the_title( $t_mousemove_caption_image_id ); ?></span>
                        <span class="sdtp-cross"></span>
                    </div>
                </li>
            </ul>
        </li>
        <?php
    }

    function update_value( $slide, $data )
    {
        if( ! isset( $data['_transitionpro_type'] ) || empty( $slide ) || empty( $data ) ) return;

        if( $data['_transitionpro_type'] === 'scroll' )
        {
            update_post_meta( $slide->ID, "_transitionpro_type", 'scroll' );

            if( isset( $data['_t_scroll_caption_image'] ) ){
                update_post_meta( $slide->ID, "_t_scroll_caption_image", $data['_t_scroll_caption_image'] );
            }

            if( isset( $data['_t_scroll_data_depth'] ) ){
                update_post_meta( $slide->ID, "_t_scroll_data_depth", $data['_t_scroll_data_depth'] );
            }


        }
        else if( $data['_transitionpro_type'] === 'mousemove' )
        {
            update_post_meta( $slide->ID, "_transitionpro_type", 'mousemove' );


            if( isset( $data['_t_mousemove_data_depth'] ) ){
                update_post_meta( $slide->ID, "_t_mousemove_data_depth", $data['_t_mousemove_data_depth'] );
            }

            if( isset( $data['_t_mousemove_caption_image'] ) ){
                update_post_meta( $slide->ID, "_t_mousemove_caption_image", $data['_t_mousemove_caption_image'] );
            }

            if( isset( $data['_t_mousemove_layer_1'] ) ){
                update_post_meta( $slide->ID, "_t_mousemove_layer_1", $data['_t_mousemove_layer_1'] );
            }

            if( isset( $data['_t_mousemove_layer_2'] ) ){
                update_post_meta( $slide->ID, "_t_mousemove_layer_2", $data['_t_mousemove_layer_2'] );
            }

            if( isset( $data['_t_mousemove_layer_3'] ) ){
                update_post_meta( $slide->ID, "_t_mousemove_layer_3", $data['_t_mousemove_layer_3'] );
            }

        }
    }

    function if_isset( $key , $array, $default_value = false ){
        return isset( $array[$key] ) ? $array[$key] : $default_value;
    }

    function add_layers( $content, $slide, $slidedeck )
    {
        $slide_id    = isset( $slide['id'] ) ? $slide['id'] : false;
        $slide_index = $this->slide_count;
        $lens     = isset( $slidedeck['lens'] ) ? $slidedeck['lens'] : false;

        //return;
        if( $lens !== 'transitionpro' ) return $content;

        $this->slide_count++;

        if( ! $slide_id ) return;

        $scroll_meta_keys = array(
                            '_t_scroll_caption_image'
                            );

        $mousemove_meta_keys = array(
                        '_t_mousemove_caption_image' ,
                        '_t_mousemove_layer_1',
                        '_t_mousemove_layer_2',
                        '_t_mousemove_layer_3'
                    );

        $transitionpro_type = get_post_meta( $slide_id, '_transitionpro_type', true );

        if( ! $transitionpro_type ) return;

        $options = $slidedeck['options'];

        $data   = array(
                        'class'                   => "sdtp-layers transitionpro-type-{$transitionpro_type}" ,
                        'data-transitionpro-type'      => $transitionpro_type,
                        'data-continueScrolling'  => $this->if_isset( 'continueScrolling', $options ),
                        'data-autoPlay'           => $this->if_isset( 'autoPlay', $options ),
                        'data-autoPlayInterval'   => $this->if_isset( 'autoPlayInterval', $options ),
                        'data-cycle'              => $this->if_isset( 'cycle', $options ),
                        'data-slideTransition'    => $this->if_isset( 'slideTransition', $options ),
                        'data-speed'              => $this->if_isset( 'speed', $options ),
                        'data-keys'               => $this->if_isset( 'keys', $options ),
                        'data-scroll'             => $this->if_isset( 'scroll', $options ),
                        'data-start'              => $this->if_isset( 'start', $options ),
                        'data-display-nav-arrows' => $this->if_isset( 'display-nav-arrows', $options ),
                        'data-touch'              => $this->if_isset( 'touch', $options ),
                        'data-navigation_type'         => $this->if_isset('navigation-type', $options),
                        'data-navigation'        => $this->if_isset('display-navigation', $options),
                        'data-progressBar' => $this->if_isset('progressBar', $options),

                    );

        $data_string = '';

        foreach ( $data as $attr => $value ) {
            $data_string .= "{$attr}='{$value}' ";
        }

        $markup = "<ul {$data_string} >";

        if( $transitionpro_type === 'scroll' ){

            $data_depth = intval(get_post_meta( $slide_id, '_scroll_data_depth', true ));
            foreach ( $scroll_meta_keys as $key => $meta_key ) {
                $markup .= $this->get_layer( $slide_id, $meta_key, $key, $data_depth );
            }

        }
        else if( $transitionpro_type === 'mousemove' ){

            $data_depth = intval(get_post_meta( $slide_id, '_mousemove_data_depth', true ));

            foreach ( $mousemove_meta_keys as $key => $meta_key )
            {
                $markup .= $this->get_layer( $slide_id, $meta_key, $key , $data_depth );
            }
        }

        if( $this->is_preview() ){
            /*
            $markup .= "<div class='sdtp-layer-actions'>";
            $markup .=  "<button class='button sdtp-add-opacity' >Add Opacity</button>";
            $markup .=  "<button class='button sdtp-save-layers' >Save</button>";
            $markup .= "</div>";
             * */

        }

        $markup .= "</ul>";

        return $markup . $content;
    }

    function get_layer( $slide_id, $meta_key, $key, $data_depth )
    {
        $markup = false;
        $key++;
        $default_data_depth =  $key * 6 / 10;
        $depth = $data_depth > 0 ? $default_data_depth * ($data_depth/10) : $default_data_depth;

        $attachment_id    = get_post_meta( $slide_id, $meta_key , true );
        $layer_data       = get_post_meta( $slide_id, $meta_key . '_data' , true );
        $position_x       = isset( $layer_data['cordinates'] ) && ! empty( $layer_data['cordinates'] ) ? $layer_data['cordinates'][0] : false;
        $position_y       = isset( $layer_data['cordinates'] ) && ! empty( $layer_data['cordinates'] ) ? $layer_data['cordinates'][1] : false;
        $data   = array(
                        'class'           => 'layer sdtp-slide-layer sdtp-scroll-caption-layer' ,
                        'data-depth'      => $depth,
                        'data-selected-depth' => $data_depth,
                        'data-layer'      => $meta_key,
                        'data-z-index'    => $this->if_isset( 'z_index' , $layer_data ),
                        'data-position-x' => $position_x,
                        'data-position-y' => $position_y
                        );

        $data_string = '';

        foreach ( $data as $attr => $value ) {
            $data_string .= "{$attr}='{$value}' ";
        }

        $attachemnt_image = wp_get_attachment_image( $attachment_id, 'full', false );

        if( $attachemnt_image ){
            $markup = "<li {$data_string} >";
            $markup .= $attachemnt_image;
            $markup .= '</li>';
        }

        return $markup;
    }

    function save_layers()
    {
        $layers = $this->if_isset( 'layers' , $_REQUEST );

        $response = "error saving the layer...";

        if( empty( $layers ) ) return;

        foreach ( $layers as $layer )
        {
            $data               = array();
            $slide_id           = $this->if_isset( 'slide_id' , $layer );
            $layer_meta_key     = $this->if_isset( 'layer' , $layer );
            $data['cordinates'] = $this->if_isset( 'per_cordinates' , $layer );
            $data['z_index']    = $this->if_isset( 'z_index' , $layer );

            if( ! $slide_id || ! $layer_meta_key ) continue;

            update_post_meta( $slide_id , $layer_meta_key . '_data' , $data  );

            $response = "Layer Saved..";

        }

        die(json_encode( $response ));
    }

}
