(function($){
	SlideDeckLens['lens-trifect'] = function(slidedeck){
        var slidedeck = $(slidedeck);
        var slidedeckFrame = slidedeck.closest('.slidedeck-frame');
        var deck = slidedeck.slidedeck();
        var deckElement = slidedeck;

        // Only for IE - detect background image url and update style for DD element
        if( slidedeck_ie <= 8.0 ){
            deck.slides.each(function(ind){
                var imageDiv = $(deck.slides[ind]).find('div.image');
                var shadowDiv = $(deck.slides[ind]).find('div.sd2-shadow-element');
                var tapeDiv = $(deck.slides[ind]).find('div.sd2-tape-element');
                if( imageDiv.css('background-image') != 'none' ){
                    var imgurl = imageDiv.css('background-image').match( /url\([\"\'](.*)[\"\']\)/ )[1];

                    // IE8 has issues with background image AND relative paths...
                    shadowDiv.css({
                        background: 'none'
                    });
                    tapeDiv.css({
                        background: 'none'
                    });

                    imageDiv.css({
                        background: 'none'
                    });
                    imageDiv[0].style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + imgurl + "', sizingMethod='scale')";
                };
            });
        }

        // For stacked layout
        if( slidedeckFrame.hasClass( 'layout-stacked' ) ){
            deck.slides.each(function(ind){
                var slide = deck.slides.eq(ind).find('.slide-content');

                var rotate = Math.round(Math.random() * 2.5);
                if(Math.round(Math.random()) == 0){
                    rotate = 0 - rotate;
                }

                var slideCSS = {};
                    slideCSS['-webkit-transform-origin'] = '50% 50%';
                    slideCSS['-moz-transform-origin'] = '50% 50%';
                    slideCSS['-o-transform-origin'] = '50% 50%';
                    slideCSS['transform-origin'] = '50% 50%';
                    slideCSS['-webkit-transform'] = 'rotate3d(0,0,1,' + rotate + 'deg) scale3d(0.8,0.8,0.8)';
                    slideCSS['-moz-transform'] = 'rotate(' + rotate + 'deg) scale(0.8)';
                    slideCSS['-o-transform'] = 'rotate(' + rotate + 'deg) scale(0.8)';
                    slideCSS['transform'] = 'rotate(' + rotate + 'deg) scale(0.8)';

                slide.css(slideCSS);

            });
        }

        // rotate tape
        deck.slides.each(function(ind){
            var tape = deck.slides.eq(ind).find('.sd2-tape-element');

            var rotate = Math.round(Math.random() * 4);
            if(Math.round(Math.random()) == 0){
                rotate = 0 - rotate;
            }

            var tapeCSS = {};
                tapeCSS['-webkit-transform-origin'] = '50% 50%';
                tapeCSS['-moz-transform-origin'] = '50% 50%';
                tapeCSS['-o-transform-origin'] = '50% 50%';
                tapeCSS['transform-origin'] = '50% 50%';
                tapeCSS['-webkit-transform'] = 'rotate3d(0,0,1,' + rotate + 'deg) scale3d(0.8,0.8,0.8)';
                tapeCSS['-moz-transform'] = 'rotate(' + rotate + 'deg) scale(0.8)';
                tapeCSS['-o-transform'] = 'rotate(' + rotate + 'deg) scale(0.8)';
                tapeCSS['transform'] = 'rotate(' + rotate + 'deg) scale(0.8)';

            tape.css(tapeCSS);

        });

        var oldBefore = deck.options.before;
        deck.options.before = function(){
            // If the old before option was a function, run it
            if(typeof(oldBefore) == 'function')
                oldBefore(deck);

            addClasses( deck );

            if( !$.data(slidedeckFrame, 'added-transitions') ){
                $.data(slidedeckFrame, 'added-transitions', true );
                var transitionSpeed = deck.options.speed / 4;

                deck.slides.find('.slide-content, .paper').css({
                    '-webkit-transition': 'all ' + transitionSpeed + 'ms cubic-bezier(0.000, 0.000, 0.230, 0.995)',
                    '-moz-transition': 'all ' + transitionSpeed + 'ms cubic-bezier(0.000, 0.000, 0.230, 0.995)',
                    '-o-transition': 'all ' + transitionSpeed + 'ms cubic-bezier(0.000, 0.000, 0.230, 0.995)',
                    'transition': 'all ' + transitionSpeed + 'ms cubic-bezier(0.000, 0.000, 0.230, 0.995)',
                });

            }
        }

        // deck.loaded( function(){
        //     addClasses( deck );
        //     fixHeight();
        // });
		//
        // var fixHeight = function() {
        //     if( !slidedeckFrame.hasClass( 'sd2-show-circular-frame' ) ) {
        //         if( slidedeckFrame.hasClass( 'layout-stacked' ) ) {
        //             slidedeckFrame.find('dd .paper .image').css({
        //                 height: slidedeckFrame.find('dd .paper .image:first').width()
        //             });
        //         }
        //     }
		//
        // }

        var addClasses = function( deck ){
            // Add some classes to the slides that are before and after
            deck.slides.each(function(ind){
                var current = deck.current - 1;
                if( ind < current ){
                    $(deck.slides[ind]).removeClass('after-slide').addClass('before-slide');
                }else if( ind > current ){
                    $(deck.slides[ind]).removeClass('before-slide').addClass('after-slide');
                }
            });
        }
	};

    $(document).ready(function(){
        $('.lens-trifect .slidedeck').each(function(){
            if(typeof($.data(this, 'lens-trifect')) == 'undefined'){
                $.data(this, 'lens-trifect', new SlideDeckLens['lens-trifect'](this));
            }
        });
		var mediaUploader;
		jQuery("#bg-upload-img-id").click(function(e){

		    e.preventDefault();
		    // If the uploader object has already been created, reopen the dialog
		      if (mediaUploader) {
		      mediaUploader.open();
		      return;
		    }
		    // Extend the wp.media object
		    mediaUploader = wp.media.frames.file_frame = wp.media({
		      title: 'Choose Image',
		      button: {
		      text: 'Choose Image'
		    }, multiple: false });

		    // When a file is selected, grab the URL and set it as the text field's value
		    mediaUploader.on('select', function() {
		      attachment = mediaUploader.state().get('selection').first().toJSON();

		       jQuery('#bg-preview').html( '<span class="trifect-rimage" style="padding:3px 5px;border-color:rgb(216, 216, 216) rgb(209, 209, 209) rgb(186, 186, 186);border-radius:10%;border:1px solid;font-size:10px;">Remove Image</span><img src="'+attachment.url+'" alt="" style ="width:50px; height:50px;padding: 10px;" / >' );
		       jQuery("#options-bg-custom-img-url").val(attachment.url);
		    });
		    // Open the uploader dialog
		    mediaUploader.open();


		});
		jQuery(document).on('click', '.trifect-rimage', function(){
		    jQuery('#bg-preview img').hide();
		    jQuery("#options-bg-custom-img-url").val('');
		    return false;
		});

    });
})(jQuery);
! function(a) {
    SlideDeckLens['lens-trifect'] = function(b) {
		var c = function() {
                for (var a, b = 3, c = document.createElement("div"), d = c.getElementsByTagName("i"); c.innerHTML = "\x3c!--[if gt IE " + ++b + "]><i></i><![endif]--\x3e", d[0];);
                return b > 4 ? b : a
            }(),
            e = a(b).slidedeck(),
            f = e.vertical(),
            g = {};
        g.slidedeck = e.deck, g.frame = g.slidedeck.closest(".lens-trifect"), g.slides = e.slides, g.deckWrapper = g.frame.find(".sd-wrapper"), g.horizNav = g.frame.find(".deck-navigation.horizontal"), g.horizNavPrev = g.frame.find(".deck-navigation.horizontal.prev"), g.horizNavNext = g.frame.find(".deck-navigation.horizontal.next"), g.vertNav = g.frame.find(".deck-navigation.vertical"), g.vertNavPrev = g.frame.find(".deck-navigation.vertical.prev"), g.vertNavNext = g.frame.find(".deck-navigation.vertical.next"), g.slidedeck.find(".sd2-slide-text a").addClass("accent-color"), e.loaded(function(b) {
            var d = !1;
            g.frame.find(".slidesVertical").length && (d = !0), d && (g.slides = b.vertical().slides, f.options.scroll = !!b.options.scroll);
            var e = g.frame.parent();
            slidedeck_fullwidth = function() {

                var a = jQuery(window).width();
				g.slidedeck.css({
					width : a*0.33
				});
				g.slidedeck.find('dd').css({
					width : a*0.33
				});
                e.css({
                    position: "absolute",
                    width: a,
                    "max-width": a,
                    left: 0
                });
				e.find('dl').css('{height:100%}');
                var b = e.attr("style");
                e.attr("style", b + "width: " + a + "px !important;"), g.frame.css({
                    width: a + "px",
                    height: "auto",
                     left: 0 - e.offset().left + "px"
                }), g.frame.find("dl dd.slide").addClass("sd-fullwidth-active"), g.frame.find(".sd-fullwidth-active").css({
                    width: a + "px !important",
                    "margin-top": "0px",
                });
				var active = -(a*0.33);
				var prev = 0;
				var next = a*0.33;
				if(a > 700) {
					e.find('.sd-fullwidth-active.active').prev().css({left: active+'px'});
					e.find('.sd-fullwidth-active.active').next().css({left: next+'px'});
				}
				else {
					var negative_left = -(a);
					e.find('.sd-fullwidth-active.active').next().css({left: a+'px'});
					e.find('.sd-fullwidth-active.active').prev().css({left: negative_left+'px'});
					e.find('.sd-fullwidth-active.active').next().next().css({left: a+'px'});
				}
                var c;
                c = a < 700 ? e.find("img").height() + 40 : g.frame.height() + 40, jQuery(".slidedeck-fullwidth-container").length || e.after('<div class="slidedeck-fullwidth-container" style="width: 100%; height: ' + c + 'px;"></div>')
				
			}, g.frame.hasClass("lens-trifect") == true && slidedeck_fullwidth();
			jQuery(document).on('click', '.deck-navigation', function(){
				slidedeck_fullwidth();
			})

	})
	}
}(jQuery);
